<!-- Copyright 2000 SAS Institute Inc, Cary, NC, 27513 -->
<%@page import="java.io.*,java.util.*" %>
<%
/*********************************************************************/
// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     HRVHeadInclude.jsp
// AUTHOR:   saslmd - Lynette Dromsky
// SUPPORT:  saslmd - Lynette Dromsky
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  Include this jsp between the open & close <head> tags
//
// HISTORY:   Date    Who  Action
//           -------------------------------------------------------
//           26Oct00  lmd  initial coding
//           20Sep01  lmd  add meta tag to prevent caching of hrv pages
// S0159052  19Jul02  lmd  add timeout meta statement
// S0159052  20Sep02  lmd  remove hardcode of Hrv3
// S0166968  30Sep02  lmd  add site specified style sheet
// S0191881  09Apr03  lmd  base forward to exit on pagelogouttime
/*********************************************************************/

/*
 * This file should be included between the <head> and </head> tags
 * for all jsps that are handling the main tags of a page...
 *
 * <html>
 *   <head>
 *     <!-- include file="HRVHeadInclude.jsp" -->
 *     <!-- rest of head -->
 *   </head>
 *   <body>
 *   </body>
 * </html>
 *
 * Can't show actual include example line because it closes the jsp code
 * section and treats the rest of the example as html.  But you get the 
 * gist.
 *
 * Right now the file is very simple, but may later be expanded.
 */
%>

<!--  <link href="../Html/sas_blue.css" rel="STYLESHEET" type="text/css"> -->
  <link href="../Html/sasads.css" rel="STYLESHEET" type="text/css">
  <link href="../Html/sasStyle.css" rel="STYLESHEET" type="text/css">
  <link href="../Html/HRVstyles.css" rel="STYLESHEET" type="text/css">

<%
	// get user specified style sheet
	String siteStyle = null;
	try
	{
		siteStyle = (String)hrvi.getConfigValue( "site.style.css" );
//System.out.println( "   siteStyle="+siteStyle );		
	}
	catch( Exception e ){}

	if( siteStyle != null && siteStyle.length() > 0 )
	{
%>		
  <link href="<%=siteStyle%>" rel="STYLESHEET" type="text/css">
<%
	}

	// Add one minute to timeout.  This gives precedence to the
	// frameset timeout.  It reduces the likelyhood that multiple
	// logout screens will appear in the various frames.
	String lifespanMinutes = (String)HrvInfo.getConfigValue("pagelogouttime");
	if( lifespanMinutes == null || lifespanMinutes.length() <= 0 )
		lifespanMinutes = (String)HrvInfo.getConfigValue("lifespan");
	int    lifespanSeconds = (Integer.parseInt( lifespanMinutes )+1) * 60;
	String lifespan = Integer.toString( lifespanSeconds );
	String timeoutStatement = "<meta http-equiv=\"refresh\" content=\""+lifespan+"; url=../Jsp/exitHRV.jsp\">";
%>

  <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
  <%=timeoutStatement%>
