<% 
 /*********************************************************************/
 // Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
 /*********************************************************************/
 //
 // NAME:     AuxItem.jsp
 // AUTHOR:   sastgl - Tim Lehman
 // SUPPORT:  sastgl - Tim Lehman
 // PRODUCT:  hrvision  
 // TYPE:     jsp page      
 // LANGUAGE: java
 // PURPOSE:  handle parameters and commands for adding, deleting and 
 //                             editing "items", where items can be specified by how 
 //                             certain methods are implemented.  See bottom for 
 //                             implementation details for those methods.
 //
 // HISTORY:   Date    Who     Action
 //           -------------------------------------------------------
 //           20Dec00  TGL     initial coding
 //               23Apr01  maperr  added JavaScript for userlistBtns.jsp
 //                                                 codelistBtns.jsp
 //                       13Jun01  maperr  added error checking and headings
 //
 // NOTES:              Usage of this JSP requires additional methods.
 //                             See commented method documention below                  
 /*********************************************************************/
 %>   
                        
 <html>        
           
 <head>
   
 <%@ include file="HRVHeadInclude.jsp"%>   
 
 <script language="JavaScript">
        function doNew()
        {
                document.NEWFORM.COMMAND.value='NEW';
                document.NEWFORM.submit(); 
        }
        function doReset()
        {
                document.ATTRFORM.COMMAND.value='RELOAD';
                document.ATTRFORM.submit();
        } 
        function doUpdate()
        {
                document.ATTRFORM.COMMAND.value='UPDATE';
                document.ATTRFORM.submit();   
        } 
        function doDelete()  
        {    
                document.ATTRFORM.COMMAND.value='DELETECONFIRM';   
                document.ATTRFORM.submit();  
        } 
        function doList()
        {
                document.ATTRFORM.COMMAND.value='LIST';
                document.ATTRFORM.submit();
        } 
 
        function doDeleteConfirm()
        {
                document.DELETEFORM.COMMAND.value='DELETE';
                document.DELETEFORM.submit();
        } 
        function doDeleteCancel()
        {
                document.DELETEFORM.COMMAND.value='DELETECANCEL';
                document.DELETEFORM.submit();
        }       
 
</script>
 
 <SCRIPT LANGUAGE="JavaScript" SRC="../Html/calendar.js"></SCRIPT>
 <SCRIPT LANGUAGE="JavaScript" SRC="../Html/changeCursor.js"></SCRIPT>

 </head>
 
 <body class="bodyContents" topmargin="2px" leftmargin="2px" rightmargin="0">
 <%
        
        AuxItem AI = new AuxItem();
        AI.setTargetJSP(targetJSP);
        AI.setAttrNuemonic(attrNuemonic);
        AI.setKeyAttrName(session, keyAttrName);
                        
   CodeBean cb = hrvi.getCodeBean(session);
        
   Set codes = cb.getSecurityCodes();
   VisMsg    VM   = VisMsg.getInstance(session);
   String attrName, attrString, oldKey="", edit=""; 
   
   String newTopic = VM.getLabel("TOP_NEWTOPIC.txt");
   //****
   //***********initial loading **********
   //****
   

        //*** load the passed in parameters
        NamedList parmList = new NamedList(true);  
        for (Enumeration parmNames = request.getParameterNames(); parmNames.hasMoreElements() ;) {
                
                attrName = (String) parmNames.nextElement();
                String[] attrValue;
                attrValue = request.getParameterValues(attrName);
                
                StringBuffer finalStr = new StringBuffer();
                
                for(int j=0; j < attrValue.length; j++) {
                        if(j > 0)
                                finalStr.append("*");
                        finalStr.append(attrValue[j]);
                }
                
                attrString = finalStr.toString();               
                parmList.add(attrName,attrString);
        }
        
        // get the command parameter, if present
        String command = request.getParameter("COMMAND");
        if (command == null) command = request.getParameter("command");
        if (command == null) command = "LIST";
        command = command.toUpperCase();
         
        // load up the possible attributes, using SYSADM as the template, insure attrList has the same entries
        NamedList possibleList = new NamedList(true);
        initKeys(session, "SYSADM", possibleList, "INIT");  

        // list to hold the actual original attributes
    NamedList attrList = new NamedList(true);  


        //adds the proper attributes to the list. To be populated in initKeys()
        for (int i=0; i < possibleList.length(); i++) {
                attrName = possibleList.getName(i);
        
                attrList.add(attrName,"");
        }       
        
        // get the key parameter, try both upper and lower case
        String key = request.getParameter(keyAttrName.toUpperCase());
        if (key == null) key = request.getParameter(keyAttrName.toLowerCase()); 

        if(command.equalsIgnoreCase("RELOAD"))
                key = request.getParameter("userName"); 
        
        if(command.equalsIgnoreCase("UPDATE")){
                oldKey = request.getParameter("userName");
                edit = request.getParameter("edit");
        }
                
        // load up which attributes need a choice of some kind
    NamedList choiceList = new NamedList(true); 
    if(attrNuemonic.equalsIgnoreCase("CodeAttr_")){
        choiceList.add("key", key);   
        choiceList.add("command", command); 
        
    }
        getChoiceList(session, possibleList, choiceList);
        
        // get the display keys for the attributes
        NamedList displayList = new NamedList(true);
        AI.getDisplayKeys(possibleList, displayList);
        
        // load up the key attributes, if the key is blank or invalid, this will remain empty.
        initKeys(session, key, attrList, "REPLACE");
        
        // specify which keys cannot be deleted
        LinkedList noDeleteList = new LinkedList();
        fillNoDeleteList(noDeleteList);
        //****   
        //***********end of initial loading **********
        //****
        //set up the correct button paths      
        String buttonPath = "";
        if(attrNuemonic.equalsIgnoreCase("TopicsAttr_"))
                buttonPath = "manageTopicsBtns.jsp";    
        else if(attrNuemonic.equalsIgnoreCase("UserAttr_"))
                buttonPath = "userlistBtns.jsp";
        else if(attrNuemonic.equalsIgnoreCase("CodeAttr_"))
                buttonPath = "codelistBtns.jsp";
        else if(attrNuemonic.equalsIgnoreCase("LinksAttr_"))
                buttonPath = "manageLinksBtns.jsp";
           
           
   //****                
   //************process the commands
   //****    
   // LIST *- list all keys and their attributes in one table
        if (command.equals("LIST")) {
                out.println("<H1>" + VM.getLabel(attrNuemonic + "title") + "</h1>");
                if(attrNuemonic.equalsIgnoreCase("UserAttr_")){
                        String direction = request.getParameter("direction");
                        if(direction != null && !direction.equals("")){
                                String sortOrder = (String)session.getAttribute("sortOrder");
                                if(sortOrder != null && sortOrder.equalsIgnoreCase("decending")){
                                        session.setAttribute("sortOrder", "assending");
                                }else if(sortOrder != null){
                                        session.setAttribute("sortOrder", "decending");
                                }
                        }
                        
                        OptionBean oB = OptionBean.getInstance(session);
                        String numberUsers = (String)oB.getOption("users_rows");
                        int displayNumber = Integer.parseInt(numberUsers);
                        int currentNumber = 0;
                        
                        String currentNum = (String)session.getAttribute("currentNum");
                                
                        if(currentNum == null || currentNum.equals("")){
                                session.setAttribute("currentNum", "0");
                        }else{
                                int newNumber = 0;
                                currentNumber = Integer.parseInt(currentNum);
                                if(direction != null && direction.equalsIgnoreCase("forward")){
                                        newNumber = currentNumber + displayNumber;
                                }else if(direction != null && direction.equalsIgnoreCase("back")){
                                        newNumber = currentNumber - displayNumber;
                                }else{
                                        newNumber = currentNumber;
                                }
                                 
                                String tempString = Integer.toString(newNumber);
                                session.setAttribute("currentNum", tempString);
                        }  
                }     
                keyList(session, parmList, possibleList, displayList, AI);
                %>
                        <script language="JavaScript">
                                parent.BUTTONS.document.location.href='../Jsp/<%=buttonPath%>?COMMAND=LISTLOADED';
                        </script>
                <%  
        }         
      
   // DISPLAY  * - list one key and it's attributes
        else if (command.equals("DISPLAY") || command.equals("DELETECANCEL")) {
                out.println("<CENTER><h1>" + VM.getLabel(attrNuemonic + "edit") + "</CENTER></h1>");
                AI.writeTable(key, codes, attrList, choiceList, displayList, !true);
                
                //if(attrNuemonic.equalsIgnoreCase("LinksAttr_")){
                        session.setAttribute("isNew", "");
                        session.setAttribute("linkKey", key);
                //}
                %>
                        <script language="JavaScript">
                                document.ATTRFORM.userName.value = '<%=key%>';
                                document.ATTRFORM.edit.value = 'true';
                        </script>
                <%                  
        }
      
   // RELOAD - reloads the users saved values
        else if(command.equals("RELOAD")){
                String oldUserName = request.getParameter("userName");  
                String isThisNew = (String)session.getAttribute("isNew");
                String linkName = (String)session.getAttribute("linkKey");   
                if(linkName == null || linkName.equals("")){
                        session.setAttribute("linkKey", oldUserName);
                        linkName = oldUserName;
                }
                
                if(isThisNew != null && isThisNew.equalsIgnoreCase("isNew")){
                        attrList.add("newItem", "new");
                        out.println("<CENTER><h1>" + VM.getLabel(attrNuemonic + "new") + "</CENTER></h1>");
                        AI.writeTable(oldUserName, codes, attrList, choiceList, displayList, !true);
                %>
                        <script language="JavaScript">
                        parent.BUTTONS.document.location.href='../Jsp/<%=buttonPath%>?COMMAND=NEW';
                        document.ATTRFORM.LINKS.value = '<%=linkName%>';
                        </script>
                <%
                }else{
                out.println("<CENTER><h1>" + VM.getLabel(attrNuemonic + "edit") + "</CENTER></h1>");
                AI.writeTable(oldUserName, codes, attrList, choiceList, displayList, !true);
                %>
                        <script language="JavaScript">
                                document.ATTRFORM.userName.value = '<%=oldUserName%>';
                                document.ATTRFORM.LINKS.value = '<%=linkName%>';  
                        </script>
                <%
                }
        }
       
   // UPDATE - displays prompt and table
        else if (command.equals("UPDATE")) {    
        
                // determine if this is a new addition or updating an old one.
                String newTest = (String)session.getAttribute("isNew");
                
                //need to delete old key, if value has changed
                if(!key.equalsIgnoreCase(oldKey) && edit.equalsIgnoreCase("true"))
                        deleteItem(session, oldKey);
                        
                //if(attrNuemonic.equalsIgnoreCase("UserAttr_") && edit.equalsIgnoreCase("true"))
                //      key = oldKey;  
                        
                if(key == null || key.equals("")){
                        out.println("<h1>" + VM.getLabel(attrNuemonic + "title") + "</h1>");
                        out.println("<p class=\"errmsg\">" + VM.getLabel(attrNuemonic + "nokey") + "</p>");
                        session.setAttribute("isNew","");
                        keyList(session, parmList, possibleList, displayList, AI);
                        %>
                                <script language="JavaScript">
                                        parent.BUTTONS.document.location.href='../Jsp/<%=buttonPath%>?COMMAND=LISTLOADED';
                                </script>
                        <%
                }
                else
                {
                        if(attrNuemonic.equalsIgnoreCase("UserAttr_") || attrNuemonic.equalsIgnoreCase("LinksAttr_")){
                                
                                
                                String password = (String)parmList.getValue("encryptpw");
                                String message = "";
                                if (!(password==null || password.equals(""))) {
                                        ValidatePassword vp = new ValidatePassword(session, password);
                                        if (!vp.isValid()) {
                                          message = vp.getErrorMessages();
                                          password = "";
                                        }
                                }
                                
                                
                                String description = (String)parmList.getValue("desc");
                                String topicUrl = (String)parmList.getValue("url");
                                
                                if(attrNuemonic.equalsIgnoreCase("UserAttr_")){
                                        description = "no worries";
                                        topicUrl = "no worries";
                                }
                                
                                if(attrNuemonic.equalsIgnoreCase("LinksAttr_")){
                                        password = "no worries";
                                }
                               
                                // Need to ensure that the user being added does not already exist.
                                UserBean ub = new UserBean(session);
                                boolean userExists = true;
                                try {
                                        ub.setUser(key);
                                }
                                catch (InvalidUserException e) {
                                        userExists = false;
                                }
                                
                                //if something is null or blank or a potential duplicate user.
                                if(password == null || password.equals("") || description == null || description.equals("") || topicUrl == null || topicUrl.equals("") ||
                                (userExists && "isNew".equals(newTest))){
                                        
                                        String linkKey = (String)parmList.getValue("userName");
                                        
                                        //do the generic stuff. **NOTE** If you are looking at this code, I feel for you badly!
                                        parmList.remove("USER");
                                        parmList.remove("COMMAND");
                                        for(int i=0; i < attrList.length(); i++){
                                                String attributeName = (String)attrList.getName(i);
                                                Object parmVal = parmList.getValue(attributeName);
                                                if(parmVal == null)
                                                        parmVal = "";
                                                attrList.setValue(parmVal, i);      
                                        }
                                        
                                        attrList.add("newItem", "new"); 
                                        
                                        if (userExists) { 
                                                // user already exists so give the appropriate message.   
                                                out.println("<p align=\"center\" class=\"errmsg\">" + VM.getSentence("UserExists") + "</p>");
                                                 AI.writeTable(key, codes, attrList, choiceList, displayList, !true);
                                        }else                                        if(attrNuemonic.equalsIgnoreCase("UserAttr_")){
                                                //if the error is due to the password missing on a user, do this
                                                if (message.equals(""))
                                                        out.println("<p align=\"center\" class=\"errmsg\">" + VM.getSentence("nopassword") + "</p>");
                                                else 
                                                        out.println("<p align=\"center\" class=\"errmsg\">" + message + "</p>");
                                                        
                                                AI.writeTable(key, codes, attrList, choiceList, displayList, !true);
                                        }else if(attrNuemonic.equalsIgnoreCase("LinksAttr_") && (description == null || description.equals(""))){
                                                out.println("<p align=\"center\" class=\"errmsg\">" + VM.getSentence("noLinkDescription") + "</p>");
                                                AI.writeTable(key, codes, attrList, choiceList, displayList, !true);
                                                if(linkKey != null && !linkKey.equals(""))
                                                        session.setAttribute("linkKey", linkKey);
                                        }else if(attrNuemonic.equalsIgnoreCase("LinksAttr_") && (topicUrl == null || topicUrl.equals(""))){
                                                out.println("<p align=\"center\" class=\"errmsg\">" + VM.getSentence("noLink") + "</p>");
                                                AI.writeTable(key, codes, attrList, choiceList, displayList, !true);
                                                if(linkKey != null && !linkKey.equals(""))
                                                        session.setAttribute("linkKey", linkKey);
                                        }  
                                        
                                        //write out the button for whatever screen you are on
                                        if(newTest.equalsIgnoreCase("isNew")){
                                        %>
                                                <Script Language="JavaScript">
                                                        parent.BUTTONS.document.location.href='../Jsp/<%=buttonPath%>?COMMAND=NEW';
                                                </Script>
                                        <%
                                        }
                                        else  
                                        {       
                                        %>
                                                <Script Language="JavaScript">
                                                        parent.BUTTONS.document.location.href='../Jsp/<%=buttonPath%>?COMMAND=DISPLAY';
                                                </Script>
                                        <%
                                        }
                                }
                                else
                                {
                                        out.println("<h1>" + VM.getLabel(attrNuemonic + "title") + "</h1>");
                                        updateNewValues(session, key, attrList, parmList); 
                                        session.setAttribute("isNew","");
                                        keyList(session, parmList, possibleList, displayList, AI);
                                %>
                                        <script language="JavaScript">
                                           parent.BUTTONS.document.location.href='../Jsp/<%=buttonPath%>?COMMAND=LISTLOADED';
                                        </script>
                                <%
                                }
                        }
                        else
                        {
                        out.println("<h1>" + VM.getLabel(attrNuemonic + "title") + "</h1>");
                        updateNewValues(session, key, attrList, parmList); 
                        session.setAttribute("isNew","");
                        keyList(session, parmList, possibleList, displayList, AI);
                        %>
                                <script language="JavaScript">
                                        parent.BUTTONS.document.location.href='../Jsp/<%=buttonPath%>?COMMAND=LISTLOADED';
                                </script>
                        <%
                        }
                }
        }
        
   // DELETECANCEL *
        //else if(command.equals("DELETECANCEL")){
        //      out.println("<CENTER><H1>" + VM.getLabel(attrNuemonic + "edit") + "</CENTER></h1>");
        //      AI.writeTable(key, codes, attrList, choiceList, displayList, !true);
        //}
        
   // DELETEPROMPT * - prompt to confirm a delete 
        else if (command.equals("DELETECONFIRM")) {
                        AI.deleteItemPrompt(key);
        }   
        
   
   // DELETE  * - delete one item 
        else if (command.equals("DELETE")) {
                if (! noDeleteList.contains(key)) {
                        try {
                                deleteItem(session, key);
                    }
                    catch (Exception e) {
                        e.printStackTrace(); 
                                out.println("<p class=\"errmsg\">Failed to delete " + key + "</p>");
                    }
                }
                else {
                        AI.cantDelete(key);
                }
                //out.println(key + " has been deleted");
                out.println("<h1>" + VM.getLabel(attrNuemonic + "title") + "</h1>");
                keyList(session, parmList, possibleList, displayList, AI);
                %>
                        <script language="JavaScript">
                                parent.BUTTONS.document.location.href='../Jsp/<%=buttonPath%>?COMMAND=LISTLOADED';
                        </script>
                <%
        }
        
    // NEW  * - create one new key
        else if (command.equals("NEW")) {
                out.println("<CENTER><h1>" + VM.getLabel(attrNuemonic + "new") + "</CENTER></h1>");
                // find a unique new key
                int i;
                for (i = 1; i < 100; i++) {
                        if(attrNuemonic.equalsIgnoreCase("TopicsAttr_"))
                                key = newTopic;
                        else{
                                key = VM.getLabel(attrNuemonic + "NEWITEMBASE") + i;
                                session.setAttribute("linkKey", key);
                        }
                        if (!initKeys(session, key, attrList, "REPLACE"))
                        {
                                break;
                        }
                }
                if (i == 100) out.println("<br>" + VM.getLabel(attrNuemonic + "INVALIDKEY"));
                else {
                        boolean manageUser = false;
                        if(attrNuemonic.equalsIgnoreCase("UserAttr_")){
                                attrList.add("newItem", "new");
                                manageUser = true;
                        }
                        session.setAttribute("isNew", "isNew");
                        AI.writeTable(key, codes, attrList, choiceList, displayList, !true, manageUser);        
                        %>
                                <script language="JavaScript">
                                        //document.ATTRFORM.ISNEW.value = 'isNew';
                                        document.ATTRFORM.userName.value = '<%=key%>';
                                </script>  
                        <%
                }  
        }else if (command.equals("SEARCH")) { 
          out.println("<H1>" + VM.getLabel(attrNuemonic + "title") + "</h1>");
           String criteria = request.getParameter("criteria");
           searchForUser(session, criteria, parmList, possibleList, displayList, AI);       
        }
        // unknown command
        else out.println("<br>" + VM.getLabel(attrNuemonic + "NOCOMMAND"));      
   

///**
// * update the values for one row item
// *
// * @param key - the key attribute variable name (String)
// * @param attrList - the current attribute values
// * @param parmList - a list containing 0 or more new attribute values to be updated
// * @return void
// */
////void updateNewValues(String key, NamedList attrList, NamedList parmList)
////    throws Exception {}
//
//    
//**
// * writes the entire table, this method must call AI.writeAllRows to do the actual writing
// *  
// * @param possibleList - the list of all possible attributes for an item
// * @param displayList - the display text for the the attributes
// * @param parmList - a list containing 0 or more new attribute values to be updated
// * @param AI - class containing the supporting print methods
// * @return void
// */
////void keyList(NamedList parmList, NamedList possibleList, NamedList displayList, AuxItem AI) 
//// throws Exception {}
//
//
///**  
// * loads from metadata the current attributes for a given key
// *
// * @param key - the key attribute variable name (String)
// * @param attrList - the list to hold the current attributes for the specified key
// * @param mode - boolean to determin whether the list should be initially cleared prior to loading
// * @return boolean - whether the initialization was successful or not
// */
//// load up the initial attribute values for this key
////boolean initKeys(String key, NamedList attrList, String mode) 
////    throws Exception{}
//
//
///**
// * enforce the key naming rules
// *
// * @param key - the key attribute variable name (String)
// * @return boolean - whether the key attribute name is a valid name or not
// */
////boolean validItemName(String key) {}
//
//
///**
// * delete an item
// *
// * @param key - the key attribute name for the item to be deleted
// */
////void deleteItem(String key) throws Exception {}
//
//
///**
// * fills a list of those attributes which need to have some kind of choice selection next to their value 
// *
// * @param attrList - list of all attibutes
// * @param choiceList - this list should be filled with those attributes that need a choice and what kind of choice
// */
////void getChoiceList(NamedList attrList, NamedList choiceList) throws Exception {}
//
//
//
///**
// * fills a list of those keys which cannot be deleted 
// *
// * @param noDeleteList - list of keys that cannot be deleted
// */
////void fillNoDeleteList(LinkedList noDeleteList) {}
//
//
%>
 
</body>
</html>