<%@page import="java.io.*,java.lang.*" %>
<%@page import="com.sas.hrv.*" %>

<%
/*********************************************************************/
// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     changehier.jsp
// AUTHOR:   cahadd - Casey Hadden
// SUPPORT:  cahadd - Casey Hadden
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  change hierarchy settings used in orgchart
//
// HISTORY:   Date    Who  Action
//           -------------------------------------------------------
//           06Nov00  jch  initial coding
/*********************************************************************/
%>

<%@include file="HRVLoginInclude.jsp"%>

<html>

<head>
    <%@include file="HRVHeadInclude.jsp"%>
</head>

<%

//
//             onClick="setDateField(document.changehier.ebdate);
//             top.newWin = window.open('../Html/calendar.html', 'cal', 'dependent=yes, width=210, height=230,left='
//             + event.screenX + ', top=' + event.screenY + ', titlebar=yes')"

VisMsg vM = VisMsg.getInstance (session);
try {
    final String DESC_STRING = "desc";
    final String PARENT_STRING = "parent";

    String label = "";
    String name = "";

    // message for the page
    NamedList labelList = vM.getLabelList ("ORGHIER_*");
    NamedList msgList = vM.getSentenceList ("ORGHIER_*");

    String windowName = request.getParameter ("windowname");
    if (windowName == null)
        windowName = "";

    // get all the current settings
    HttpSession thisSession = request.getSession ();
    String key = (String)thisSession.getAttribute (windowName + "key");
    String instance = (String)thisSession.getAttribute (windowName + "instance");

    OrgPropBean properties = (OrgPropBean)session.getAttribute(key+instance);
//  OrgPropBean properties = (OrgPropBean)HrvInfo.getSessionValue (session, key + instance);

    // hierarcy side
    String pHierTable = properties.getHierTable ();
    String pHierLvl = properties.getHierLvl ();
    String pParentLvl = properties.getParentLvl ();
    NamedList pNodeDesc = properties.getNodeDesc ();

    // employee side
    String pEmpTable = properties.getEmpTable ();
    NamedList pAnalCols = properties.getAnalVars ();
    NamedList pGroupCols = properties.getGroupVars ();
    
    StringBuffer pNodeDescString = new StringBuffer ("");
    StringBuffer pAnalColsString = new StringBuffer ("");
    StringBuffer pGroupColsString = new StringBuffer ("");
    
    // make strings that can be used to create javascript arrays
    for (int i = 0; i < pNodeDesc.size (); i++) {
        pNodeDescString.append ("\"" + pNodeDesc.getName (i) + "\"");
        if (i < (pNodeDesc.size () - 1)) {
            pNodeDescString.append (",");
        }
    }
    for (int i = 0; i < pAnalCols.size (); i++) {
        pAnalColsString.append ("\"" + pAnalCols.getName (i) + "\"");
        if (i < (pAnalCols.size () - 1)) {
            pAnalColsString.append (",");
        }
    }
    for (int i = 0; i < pGroupCols.size (); i++) {
        pGroupColsString.append ("\"" + pGroupCols.getName (i) + "\"");
        if (i < (pGroupCols.size () - 1)) {
            pGroupColsString.append (",");
        }
    }
        
    // list containing table names that are hierarchy tables
    NamedList hierTableList = new NamedList ();
    NamedList hierDateList  = new NamedList ();
    
    // lists of lists
    // each contains 1 list per table for the various attributes we'll
    // need to display on this page
    NamedList hierLvlList   = new NamedList ();
    NamedList parentList    = new NamedList ();
    NamedList nodeDescList  = new NamedList ();
    
    TableBean tables = new TableBean (session);
    // add the column filter
    tables.setColumnFilter("parent != \"\"");
    // get all table items
    List tableList = tables.getItems ();
    
    //Added by sinsat on 11JAN2005 for defect S0271521 - start
    //Sorting tableList 	
    Collections.sort(tableList);
    //Added by sinsat on 11JAN2005 for defect S0271521 - end

    for (Iterator tableIter = tableList.iterator (); tableIter.hasNext();) {
        boolean needNewLists = true;
    
        String thisTable = (String)tableIter.next();

        tables.setMetaKey (thisTable);
                        
        NamedList curHierLvlList = null;
        NamedList curParentList = null;
        NamedList curNodeDescList = null;   

        while (tables.nextColumn()) {
                        
            if (needNewLists == true) {
                // first time in, we should create new lists for this specific table
                curHierLvlList = new NamedList ();
                curParentList = new NamedList ();
                curNodeDescList = new NamedList ();
                
                hierTableList.add (thisTable, tables.getAttributeValue (DESC_STRING));
                hierLvlList.add (thisTable, curHierLvlList);
                parentList.add (thisTable, curParentList);
                nodeDescList.add (thisTable, curNodeDescList);
                // no longer need to create lists for this table
                needNewLists = false;
            }
            
            // hierlvl and parent are only single items per table, so we can 
            // add them to the lists here
            curHierLvlList.add (tables.getCurrentColumn (), tables.getColumnAttributeValue (DESC_STRING));
            curParentList.add (tables.getColumnAttributeValue (PARENT_STRING), tables.getColumnAttributeValue (PARENT_STRING));
        }
    }   
            
    // clear the column filter
    tables.setColumnFilter ("");
    // now we must do 2 things:
    //      node descriptions haven't been added yet, so we need to run back
    //          through and make those lists
    //      also we don't have the descriptions for the parent columns, only
    //          their names, so we'll get them here as well
    for (Iterator tableIter = tableList.iterator (); tableIter.hasNext();) {
        String thisTable = (String)tableIter.next();
        int tableIndex = hierTableList.indexOfName (thisTable);
        
        // if table isn't found in our list of names, then go to next one
        if (tableIndex < 0) 
            continue;
            
        tables.setMetaKey (thisTable);
        // get the lists that correspond to this table
        NamedList thisParentList = (NamedList)parentList.getValue (thisTable);
        NamedList thisNodeDescList = (NamedList)nodeDescList.getValue (thisTable);
        while (tables.nextColumn ()) {
            // add the column to the node description list
            String thisColumn = tables.getCurrentColumn ();
            String thisColumnDesc = tables.getColumnAttributeValue (DESC_STRING);
            thisNodeDescList.add (thisColumn, thisColumnDesc);
            // if this column is a parent column, then add it's desc to the parent list
            int columnParentIndex = thisParentList.indexOfName (thisColumn);
            if (columnParentIndex >= 0) {
                // column found, add the description
                thisParentList.setValue (thisColumnDesc, columnParentIndex);
            }
        }   
        
        // check the edate / eedate stuff
        if (tables.columnExists ("EDATE") && tables.columnExists ("EEDATE")) {
            hierDateList.add (thisTable, "Y");
        } else {
            hierDateList.add (thisTable, "N");
        }
    }
    
    // first sort everything
    hierTableList.sortByAscendingName (false);
    NamedList curList;
    for (int i = 0; i < hierTableList.size(); i++) {
        curList = (NamedList)hierLvlList.getValue (i);
        curList.sortByAscendingValue (false);
        curList = (NamedList)parentList.getValue (i);
        curList.sortByAscendingValue (false);
        curList = (NamedList)nodeDescList.getValue (i);
        curList.sortByAscendingValue (false);
    }
        
    
    // set up the various strings we'll need to create the javascript arrays
    int numHierTables = hierTableList.size ();
    String tableNameString = "";
    String tableLabelString = "";
    String tableDateString = "";
    String [] hierLabelString = new String [numHierTables];
    String [] hierNameString = new String [numHierTables];
    String [] parentLabelString = new String [numHierTables];
    String [] parentNameString = new String [numHierTables];
    String [] nodeDescLabelString = new String [numHierTables];
    String [] nodeDescNameString = new String [numHierTables];
    
    // now add the stuff to the arrays
    for (int i = 0; i < numHierTables; i++) {
        // first the table lists... just a simple string
        label = (String)hierTableList.getValue (i);
        name = hierTableList.getName (i);
        if (label == null || (label != null && label.equals (""))) {
            label = name;
        }
        tableNameString += "\"" + name + "\"";
        tableLabelString += "\"" + label + "\"";
        tableDateString += "\"" + hierDateList.getValue (i) + "\"";
        if (i < (numHierTables - 1)) {
            tableNameString += ",";
            tableLabelString += ",";
            tableDateString += ",";
        }
        
        // now the other lists... one string per table
        NamedList curHierLvlList = (NamedList)hierLvlList.getValue (i);
        NamedList curParentList = (NamedList)parentList.getValue (i);
        hierLabelString[i] = ""; hierNameString[i] = "";
        parentLabelString[i] = ""; parentNameString[i] = "";
        for (int j = 0; j < curHierLvlList.size (); j++) {
            // hierlvl and parentlvl have same number of entries #### ?????? ####

            label = (String)curHierLvlList.getValue (j);
            name = curHierLvlList.getName (j);
            if (label == null || (label != null && label.equals (""))) {
                label = name;
            }

            hierLabelString[i] += "\"" + label + "\"";
            hierNameString[i] += "\"" + name + "\"";

            label = (String)curParentList.getValue (j);
            name = curParentList.getName (j);
            if (label == null || (label != null && label.equals (""))) {
                label = name;
            }

            parentLabelString[i] += "\"" + label + "\"";
            parentNameString[i] += "\"" + name + "\"";
            if (j < (curHierLvlList.size() - 1)) {
                hierLabelString[i] += ",";
                hierNameString[i] += ",";
                parentLabelString[i] += ",";
                parentNameString[i] += ",";
            }
        }
        // now do the node description lists
        NamedList curNodeDescList = (NamedList)nodeDescList.getValue (i);
        nodeDescLabelString[i] = ""; nodeDescNameString[i] = "";
        for (int j = 0; j < curNodeDescList.size(); j++) {
            label = (String)curNodeDescList.getValue (j);
            name = curNodeDescList.getName (j);
            if (label == null || (label != null && label.equals (""))) {
                label = name;
            }
            nodeDescLabelString[i] += "\"" + label + "\"";
            nodeDescNameString[i] += "\"" + name + "\"";
            if (j < (curNodeDescList.size() - 1)) {
                nodeDescLabelString[i] += "," + "\n";
                nodeDescNameString[i] += "," + "\n";
            }
        }
    }
    
    // #########################################################
    // ########### NOW THE EMPLOYEE INFORMATION STUFF ##########
    // #########################################################
    
    NamedList empTableList = new NamedList ();
    NamedList empDateList = new NamedList ();
    
    NamedList analList = new NamedList ();
    NamedList classList = new NamedList ();
    NamedList columnList = new NamedList ();
        
    // use the same table bean
    for (Iterator tableIter = tableList.iterator (); tableIter.hasNext ();) {
        boolean needNewLists = true;
    
        String thisTable = (String)tableIter.next();
        
        tables.setMetaKey (thisTable);
        
/* removed master attribute from metadata 083101 - cahadd
        // get the master attribute, if it is 'H' this table is supposed
        // to be hidden from view
        String hidemode = tables.getAttributeValue ("master");
        if (hidemode != null && hidemode.equals ("H")) 
            continue;
*/                      
        // if we're here, then the table has to be added to the list,
        // even though we may not actually need it
        NamedList curAnalList = null;
        NamedList curClassList = null;
        while (tables.nextColumn ()) {
            // first time through create the lists
            if (needNewLists == true) {
                needNewLists = false;
                
                curAnalList = new NamedList ();
                curClassList = new NamedList ();
                                
                empTableList.add (thisTable, tables.getAttributeValue ("desc"));

                // get all the columns of the table, so that we can check them later
                columnList.add (thisTable, tables.getColumns());

                analList.add (thisTable, curAnalList);
                classList.add (thisTable, curClassList);
            }

            // if column doesn't have a key, then ignore it
            if (tables.getCurrentColumn ().length () == 0)
                continue;

            // if we are a grouping column, then add us to the class list
            String grouping = tables.getColumnAttributeValue ("analtype");
            if (grouping.equals ("Y")) {
                curClassList.add (tables.getCurrentColumn (), tables.getColumnAttributeValue ("desc"));
            }
            
            // if we are a numeric column, then add us to the analysis list
            String itemtype = tables.getColumnAttributeValue ("type");
            if (itemtype.equals ("N") || itemtype.equals ("M")) {
                curAnalList.add (tables.getCurrentColumn (), tables.getColumnAttributeValue ("desc"));
            }
        }
        
        // check the edate / eedate stuff
        if (!tables.getAttributeValue ("tbltype").equalsIgnoreCase ("MDDB")) {
            if (tables.columnExists ("EDATE") && tables.columnExists ("EEDATE")) {
                empDateList.add (thisTable, "Y");
            } else {
                empDateList.add (thisTable, "N");
            }
        }
    }
    
    // first sort everything
    empTableList.sortByAscendingName (false);
    for (int i = 0; i < empTableList.size(); i++) {
        curList = (NamedList)analList.getValue (i);
        curList.sortByAscendingValue (false);
        curList = (NamedList)classList.getValue (i);
        curList.sortByAscendingValue (false);
    }
    
    // now add None
    empTableList.add ("NONE", "None", 0);
    empDateList.add ("NONE", "N", 0);
    analList.add ("NONE", new NamedList (), 0);
    classList.add ("NONE", new NamedList (), 0);
    columnList.add ("NONE", new LinkedList (), 0);
    
    int numEmpTables = empTableList.size ();
    String empLabelString = "";
    String empNameString = "";
    String empDateString = "";
    String [] analLabelString = new String [numEmpTables];
    String [] analNameString = new String [numEmpTables];
    String [] classLabelString = new String [numEmpTables];
    String [] classNameString = new String [numEmpTables];
    String [] columnString = new String [numEmpTables];
    
    for (int i = 0; i < numEmpTables; i++) {
        label = (String)empTableList.getValue (i);
        name = empTableList.getName (i);
        if (label == null || (label != null && label.equals (""))) {
            label = name;
        }
        empLabelString += "\"" + label + "\"";
        empNameString += "\"" + name + "\"";
        empDateString += "\"" + empDateList.getValue (i) + "\"";
        if (i < (numEmpTables - 1)) {
            empLabelString += ",";
            empNameString += ",";
            empDateString += ",";
        }
        
        NamedList curAnalList = (NamedList)analList.getValue (i);
        NamedList curClassList = (NamedList)classList.getValue (i);
        List curColumnList = (List)columnList.getValue (i);
        
        analLabelString[i] = ""; analNameString[i] = "";
        for (int j = 0; j < curAnalList.size(); j++) {
        
            label = (String)curAnalList.getValue (j);
            name = curAnalList.getName (j);
            if (label == null || (label != null && label.equals (""))) {
                label = name;
            }
            analLabelString[i] += "\"" + label  + "\"";
            analNameString[i] += "\"" + name + "\"";
            if (j < (curAnalList.size() - 1)) {
                analLabelString[i] += "," + "\n";
                analNameString[i] += "," + "\n";
            }
        }
        
        classLabelString[i] = ""; classNameString[i] = "";
        for (int j = 0; j < curClassList.size(); j++) {
            label = (String)curClassList.getValue (j);
            name = curClassList.getName (j);
            if (label == null || (label != null && label.equals (""))) {
                label = name;
            }

            classLabelString[i] += "\"" + label + "\"";
            classNameString[i] += "\"" + name + "\"";
            if (j < (curClassList.size() - 1)) {
                classLabelString[i] += "," + "\n";
                classNameString[i] += "," + "\n";
            }
        }
        
        columnString[i] = "";
        for (int j = 0; j < curColumnList.size(); j++) {
            columnString[i] += "\"" + curColumnList.get (j) + "\"";
            if (j < (curColumnList.size() - 1)) {
                columnString [i] += "," + "\n";
            }
        }
    }   

    String formname = vM.getLabel ("ORGHIER_formname.notrans");
%>

<script language="Javascript">
<!--
  // html vars
  //var hierform = document.changehier;

  // properties arrays
  pNodeDesc = new Array (<%= pNodeDescString %>);
  pAnalCols = new Array (<%= pAnalColsString %>);
  pGroupCols = new Array (<%= pGroupColsString %>);

  hierTablesLabels = new Array (<%= tableLabelString %>);
  hierTablesNames = new Array (<%= tableNameString %>);
  
  hierDateString = new Array (<%= tableDateString %>);
  
  numHierTables = <%= numHierTables %>;
  
  hierLvlLabels = new Array (numHierTables);
  hierLvlNames = new Array (numHierTables);
  parentLvlLabels = new Array (numHierTables);
  parentLvlNames = new Array (numHierTables);
  nodeDescLabels = new Array (numHierTables);
  nodeDescNames = new Array (numHierTables); 
  
  // set up dependent arrays
  <%
  for (int i = 0; i < numHierTables; i++) {
    out.println ("hierLvlLabels[" + i + "] = new Array (" + hierLabelString[i] + ");");
    out.println ("hierLvlNames[" + i + "] = new Array (" + hierNameString[i] + ");");
    out.println ("parentLvlLabels[" + i + "] = new Array (" + parentLabelString[i] + ");");
    out.println ("parentLvlNames[" + i + "] = new Array (" + parentNameString[i] + ");");
    out.println ("nodeDescLabels[" + i + "] = new Array (" + nodeDescLabelString[i] + ");");
    out.println ("nodeDescNames[" + i + "] = new Array (" + nodeDescNameString[i] + ");");
  }
  %>

  function init () {
    var hierEntry, entry;
    // fill the boxes with options
    fillBox (document.changehier.hit, hierTablesLabels, hierTablesNames);
    hierEntry = find (document.changehier.hit, '<%= pHierTable %>');
    setBox (document.changehier.hit, hierEntry);
    
    fillBox (document.changehier.hierlvl, hierLvlLabels[hierEntry], hierLvlNames[hierEntry]);
    entry = find (document.changehier.hierlvl, '<%= pHierLvl %>');
    setBox (document.changehier.hierlvl, entry);
    
    fillBox (document.changehier.parent, parentLvlLabels[hierEntry], parentLvlNames[hierEntry]);
    entry = find (document.changehier.parent, '<%= pParentLvl %>');
    setBox (document.changehier.parent, entry);
    
    fillBox (document.changehier.description, nodeDescLabels[hierEntry], nodeDescNames[hierEntry]);
    selectArrayEntries (document.changehier.description, pNodeDesc);
    
    empInit ();
    
//  document.changehier.ebdate.value = "<%= properties.getBeginDate () %>";
//  document.changehier.eedate.value = "<%= properties.getEndDate () %>";
//  document.changehier.edate.value = "<%= properties.getEffectiveDate () %>";
  }
  
  function selectArrayEntries (ctrl, array) {
    for (i = 0; i < ctrl.options.length; i++) {
        for (j = 0; j < array.length; j++) {
            if (ctrl.options[i].value == array[j]) {
                ctrl.options[i].selected = true;
            }
        }
    }
  }
  
  function find (ctrl, string) {
    for (i = 0; i < ctrl.options.length; i++) {
        if (ctrl.options[i].value == string) {
            return i;
        }
    }
  }
  
  function setBox (ctrl, index) {
    ctrl.options[index].selected = true;
  }

  function fillBox (ctrl, labels, names) {
    clearBox (ctrl);
    for (i = 0; i < labels.length; i++) {
        ctrl.options[i] = new Option (labels[i], names[i]);
    }
  }
  
  function clearBox (ctrl) {
    curLength = ctrl.options.length;
    for (i = 0; i < curLength; i++) {
        ctrl.options[0] = null;
    }
  }
  
  function hierLvlChange (hierLvlIndex) {
    curHierLvl = document.changehier.hierlvl.options[hierLvlIndex].value;
    for (i = 0; i < document.changehier.description.options.length; i++) {
        if (document.changehier.description.options[i].value == curHierLvl) {
            document.changehier.description.options[i].selected = true;
            break;
        }
    }
  }

  function hierChange (index) {
    fillBox (document.changehier.hierlvl, hierLvlLabels[index], hierLvlNames[index]);
    fillBox (document.changehier.parent, parentLvlLabels[index], parentLvlNames[index]);
    fillBox (document.changehier.description, nodeDescLabels[index], nodeDescNames[index]);
    
    var curHierLvl = document.changehier.hierlvl.options[document.changehier.hierlvl.selectedIndex].value;
    entry = find (document.changehier.description, curHierLvl);
    setBox (document.changehier.description, entry);
    rerunEmp ();
    
//      checkDate ();
  }

  empTableLabels = new Array (<%= empLabelString %>);
  empTableNames = new Array (<%= empNameString %>);
  
  empDateString = new Array (<%= empDateString %>);
  
  numEmpTables = <%= numEmpTables %>;
  
  analLabels = new Array (numEmpTables);
  analNames = new Array (numEmpTables);
  classLabels = new Array (numEmpTables);  
  classNames = new Array (numEmpTables);
  columns = new Array (numEmpTables);
  
  <%
  for (int i = 0; i < numEmpTables; i++) {
    out.println ("analLabels[" + i + "] = new Array (" + analLabelString[i] + ");");
    out.println ("analNames[" + i + "] = new Array (" + analNameString[i] + ");");
    out.println ("classLabels[" + i + "] = new Array (" + classLabelString[i] + ");");
    out.println ("classNames[" + i + "] = new Array (" + classNameString[i] + ");");
    out.println ("columns[" + i + "] = new Array (" + columnString[i] + ");");
  }
  %>
  
  function rerunEmp () {
    fillEmpTableBox ();
    setBox (document.changehier.eit, 0);
    clearBox (document.changehier.analysis);
    clearBox (document.changehier.groups);
  }
  
  function empInit () {
    var empEntry, entry;
    fillEmpTableBox ();     // needs own function since we have to do some stuff here

    var empTable = '<%=pEmpTable%>';
    
    if (empTable != '') {
        empEntry = find (document.changehier.eit, '<%= pEmpTable %>');
        setBox (document.changehier.eit, empEntry);

        empChange (empEntry);
        selectArrayEntries (document.changehier.analysis, pAnalCols);
        selectArrayEntries (document.changehier.groups, pGroupCols);
    }
  }
  
  function fillEmpTableBox () {
    clearBox (document.changehier.eit);
    count = 1;
    // always include none
    document.changehier.eit.options[0] = new Option (empTableLabels[0], empTableNames[0]);
    for (i = 0; i < empTableLabels.length; i++) {
        curHierVar = document.changehier.hierlvl.options[document.changehier.hierlvl.selectedIndex].value;
        for (j = 0; j < columns[i].length; j++) {
            if (columns[i][j] == curHierVar) {
                document.changehier.eit.options[count] = new Option (empTableLabels[i], empTableNames[i]);
                document.changehier.eit.options[count].selected = false;
                count++;
                break;
            }
        }
    }
  }
  
  function empChange (eitIndex) {
    // figure out what table we're really on
    curEIT = document.changehier.eit.options[document.changehier.eit.options.selectedIndex].value;
    for (i = 0; i < empTableLabels.length; i++) {
        if (curEIT == empTableNames[i]) {
            eitIndex = i;
            break;
        }
    }
    clearBox (document.changehier.analysis);
    fillBox (document.changehier.analysis, analLabels[eitIndex], analNames[eitIndex]);
    clearBox (document.changehier.groups);
    fillBox (document.changehier.groups, classLabels[eitIndex], classNames[eitIndex]);
    
//      checkDate ();
  }
  
  function validateForm () {
    if (document.changehier.description.options.selectedIndex < 0) {
        // if no node description
        alert ("<%= msgList.getValue ("ORGHIER_NODEDESC") %>");
        document.changehier.description.focus ();
        return false;
    }
    
    if (document.changehier.eit.options[0].selected != true) {
        // if we haven't selected the none option
        if (document.changehier.analysis.options.selectedIndex < 0) {
            // no analysis selected
            alert ("<%= msgList.getValue ("ORGHIER_ANALVARS") %>");
            document.changehier.analysis.focus ();
            return false;
        } else if (document.changehier.groups.options.selectedIndex < 0) {
            alert ("<%= msgList.getValue ("ORGHIER_GROUPVARS") %>");
            // no groups selected
            document.changehier.groups.focus ();
            return false;
        }
    }
    if (document.changehier.save.checked == true) {
        if (false == confirm ("<%= msgList.getValue ("ORGHIER_SAVEMSG") %>")) {
            return false;
        }
    }
    
//      if (!validateDates ()) return false;
    return true;
  }

  months = new Array ("JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC");

/*  function validateDates () {
  
    beginDate = document.changehier.ebdate.value;
    endDate = document.changehier.eedate.value;
  
    // if any are missing then they are fine. 
    if (beginDate == "." || beginDate == "" ||
        endDate == "." || endDate == "")
        return true;
  
    beginDayYear = beginDate.match (/\d+/g);
    endDayYear = endDate.match (/\d+/g);
    
    beginDay = beginDayYear[0];
    beginYear = beginDayYear[1];
    endDay = endDayYear[0];
    endYear = endDayYear[1];
    
    beginMonth = beginDate.match (/[A-Z][A-Z][A-Z]/g);
    endMonth = endDate.match (/[A-Z][A-Z][A-Z]/g);
    
    for (i = 0; i < months.length; i++) {
        if (beginMonth == months[i]) {
            beginMonthNum = i;
        }
        if (endMonth == months[i]) {
            endMonthNum = i;
        }
    }
    
    jsBeginDate = new Date ();
    jsBeginDate.setTime (0);
    jsBeginDate.setMonth (beginMonthNum);
    jsBeginDate.setFullYear (beginYear);
    jsBeginDate.setDate (beginDay);
    beginTime = jsBeginDate.getTime ();
    
    jsEndDate = new Date ();
    jsEndDate.setTime (0);  
    jsEndDate.setMonth (endMonthNum);   
    jsEndDate.setFullYear (endYear);    
    jsEndDate.setDate (endDay); 
    endTime = jsEndDate.getTime ();

    if (beginTime >= endTime) {
        alert ("<%= msgList.getValue ("ORGHIER_DATES") %>");
        return false;
    }
    
    return true;
  }*/

  function submitForm () {
    if (document.<%=formname%>.cancelKey.value == "N") {
        if (validateForm ()) {
            document.<%=formname%>.submit ();
        }
    } else {
        document.<%=formname%>.submit ();
    }
  }
  
  function clearEndDate () {
    thisCtrl = eval ('document.<%=formname%>.eedate');
    clearDate (thisCtrl);
  }
  
  function clearBeginDate () {
    thisCtrl = eval ('document.<%=formname%>.ebdate');
    clearDate (thisCtrl);
  }
  
  function clearEffectiveDate () {
    thisCtrl = eval ('document.<%=formname%>.edate');
    clearDate (thisCtrl);
  }
  
  function clearDate (thisCtrl) {
    thisCtrl.value = '';
  }
  
  function checkDate () {

    hitIndex = document.<%=formname%>.hit.options.selectedIndex;
    eitIndex = document.<%=formname%>.eit.options.selectedIndex;
    
    eitValue = document.<%=formname%>.eit.options[eitIndex].value;
    for (ii = 0; ii < empTableNames.length; ii++) {
        
        if (empTableNames[ii] == eitValue) {
            eitIndex = ii;
            break;
        }

    }

    if (hierDateString[hitIndex] != 'Y' || empDateString[eitIndex] != 'Y') {
        document.<%=formname%>.edate.disabled = true;
        document.<%=formname%>.edate.value = '.';
    } else {
        document.<%=formname%>.edate.disabled = false;
    }
  }
  
  function doDate () {

    if (document.<%=formname%>.edate.disabled == false) {
        setDateField(document.changehier.edate);
        top.newWin = window.open('../Html/calendar.html', 'cal', 
        'dependent=yes, width=210, height=230,left='
        + event.screenX + ', top=' + event.screenY + ', titlebar=yes');
    } else {
        alert ('Both the Hierarchy Information Table and Employee Information Table must have EDATE and EEDATE fields to use this property.');
    }
  }

//-->
</script>

<script language="Javascript" src="../Html/calendar.js"></script>
<script language="JavaScript" src="../Html/changeCursor.js"></script>

<body class="bodyContents">

<form name="<%=formname%>" target="_top" action="orgchart.jsp" 
      onSubmit="if (cancelKey.value == 'Y') { return true; } else { if (validateForm ()) { setTimeout ('window.close ()', 500); return true; } return false; }">

<input type="hidden" name="cancelKey" value="N">
<input type="hidden" name="key" value="<%= key %>">
<input type="hidden" name="instance" value="<%= instance %>">

<table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
<tr>
<td align="center" valign="center">

<table class=entrybox cellpadding=10 cellspacing=5>
  <tr>
    <td>
      <table cellpadding=10 cellspacing=5>
        <tr>
          <td>
            <%= labelList.getValue ("ORGHIER_HIT") %> 
            <br>
            <select name="hit" style="width: 75mm" onChange="hierChange (this.selectedIndex)">
            </select>
          </td>
          <td>
            <%= labelList.getValue ("ORGHIER_EIT") %>
            <br>
            <select name="eit" style="width: 75mm" onChange="empChange (this.selectedIndex)">
            </select>
          </td>
        </tr>
        <tr>
          <td>
            <%= labelList.getValue ("ORGHIER_HIERLVL") %>
            <br>
            <select name="hierlvl" onChange="hierLvlChange (this.selectedIndex)" style="width: 60mm">
            </select>
          </td>
          <td rowspan=2>
            <%= labelList.getValue ("ORGHIER_ANALYSIS") %>
            <br>
            <select MULTIPLE name="analysis" size=4 style="width: 60mm">
            </select>
          </td>
        </tr>
        <tr>
          <td>
            <%= labelList.getValue ("ORGHIER_PARENT") %>
            <br>
            <select name="parent" style="width: 60mm">
            </select>
          </td>
        </tr>
        <tr>
          <td>
            <%= labelList.getValue ("ORGHIER_DESCRIPTION") %>
            <br>
            <select MULTIPLE name="description" size=4 style="width: 60mm">
            </select>
          </td>
          <td>
            <%= labelList.getValue ("ORGHIER_GROUPS") %>
            <br>        
            <select MULTIPLE name="groups" size=4 style="width: 60mm">
            </select>
          </td>
        </tr>
        <tr>
          <td>
            <input type="checkbox" name="save">&nbsp;&nbsp;<% out.print (labelList.getValue ("ORGHIER_save")); %>
            <!-- always make edate a missing for the time being -->
            <input type="hidden" name="edate" value=".">
          </td>  
          <td>
          </td>
<!--          <td>
            <%= labelList.getValue ("ORGHIER_EDATE") %>
            <br>
            <input type="text" name="edate" value="." class="dialogEdit" readonly>
            <a href="javascript:doNothing()" 
               onClick="doDate ()">
            <img src="../Images/smallCalendar.gif" border=0 title="Select Date" 
                 onMouseOver="changeCursor(1)" onMouseOut="changeCursor(2)">
            <font size=1>Calendar</font>
            </a>
          </td> -->
<!--          <td>
            <%= labelList.getValue ("ORGHIER_EEDATE") %>
            <br>
            <input type="text" name="eedate" value="." class="dialogEdit" readonly>
            <a href="javascript:doNothing()" 
               onClick="setDateField(document.changehier.eedate);
               top.newWin = window.open('../Html/calendar.html', 'cal', 'dependent=yes, width=210, height=230,left='
               + event.screenX + ', top=' + event.screenY + ', titlebar=yes')">
            <img src="../Images/smallCalendar.gif" border=0 title="Select Date" 
                 onMouseOver="changeCursor(1)" onMouseOut="changeCursor(2)">
            <font size=1>Calendar</font>
            </a>
          </td>

        </tr>
        <tr>
          <td>
            <input type="checkbox" name="save">&nbsp;&nbsp;<% out.print (labelList.getValue ("ORGHIER_save")); %>
          </td>  
          <td>
          </td>-->
        </tr>
      </table>
    </td>
  </tr>
</table>

</td>
</tr>
</table>

<input type="hidden" name="windowname" value="<%=request.getParameter ("windowname")%>">

</form>

<script language="Javascript">
<!--
init();
//-->
</script>

<%
} catch (Exception e) {
%>
<table width="100%" height="100%">
<tr><td valign=center align=center>

<table>
<tr>
<td valign=center align=center>
<p class="ERRMSG">

<%=vM.getLabel ("ORGCHART_errmsg_exception")%>

<br>

<%=vM.getLabel ("ORGCHART_errmsg_bookmark")%>

</p>
</td>
</tr>
</table>

</td></tr>
</table>
<%
}
%>

</body>
</html>