<HTML>
<%
/*********************************************************************/
// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     tableViewerRowSubset.jsp
// AUTHOR:   sasjs1 - Jeff Schrilla
// SUPPORT:  sasjs1 - Jeff Schrilla
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  Display available subsets.
//
//	required parameters:
//		CURRENTVIEW - the current view that is being displayed.
//
// allowed parameters:
// need to pass in three parameters.  Additional params will be passed along (persist).
// RETURNVAL = the variable name that you want the selected subset key assigned to.
// 				the default is WHERE.
/*********************************************************************/
%>
<%@page import="java.io.*,java.util.*,java.lang.Object" %>
<%@page import="com.sas.sasserver.dataset.*"%>
<%@page import="com.sas.hrv.*" %>
<%@page import="com.sas.query.datasources.*" %>
<%@page import="java.net.URLEncoder" %>
<%@include file="HRVLoginInclude.jsp"%>

<%
	VisMsg vM = VisMsg.getInstance(session);
	String desc = "";
	String errMsg = "";
	String testName = "";
	String testParam = "";
	String subDesc = "";
	String checked = "";
	String checkedSelf = "";
	String currTbl = "";

	String testParm = request.getParameter("internalAction");
	if (testParm == null)
		testParm = "";
	String jsTestParm = request.getParameter("jsTestParm");
	if (jsTestParm == null)
		jsTestParm = "";
	String secSub = request.getParameter("secSub");
	if (secSub == null)
		secSub = "n";
	String ctrlButtons = request.getParameter("ctrlButtons");
	if (ctrlButtons == null)
		ctrlButtons = "";

	String clause = request.getParameter("clause");
	if (clause == null)
		clause = "";
	String htmlClause = clause;

	// the key and location of the table that the subset is based on.
	String subsetTableKey = "";
	String subsetTableLoc = "";

	// get the location of the table we came from.
	String loc = request.getParameter("loc");
	// get the key of the table .
	String key = request.getParameter("key");
	if (key == null)
		key = "";
	if (secSub.equalsIgnoreCase("y")) {
		// set up for security subsets.
		loc = ItemBean.PUBLIC_LOC_STRING;
		if (key.equals(""))
			key = "empmast";
		else {
			// need to seperate the dsname from the key.
			int p = key.indexOf(":dsname=");
			if (p > 0) {
				currTbl = key.substring(p+8);
				key = key.substring(0,p);
			}
		}
		subsetTableLoc = loc;
		subsetTableKey = key;
	}

	// get the currentView we were looking at.
	String currentView = request.getParameter("CURRENTVIEW");
	if (currentView == null)
		currentView = "";


	String subsetLoc;
	if (hrvi.isUserAdmin(session))
		subsetLoc = ItemBean.PUBLIC_LOC_STRING;  // default to public.
	else
		subsetLoc = ItemBean.PRIVATE_LOC_STRING;  // default to private.
	String subsetKey = "";
	String PUBKEYTMP = request.getParameter("PUBKEYTMP");
	if (PUBKEYTMP != null && !PUBKEYTMP.equals("")) {
		subsetKey = PUBKEYTMP;
		subsetLoc = ItemBean.PUBLIC_LOC_STRING;
	}
	String PRVKEYTMP = request.getParameter("PRVKEYTMP");
	if (PRVKEYTMP != null && !PRVKEYTMP.equals("")) {
		subsetKey = PRVKEYTMP;
		subsetLoc = ItemBean.PRIVATE_LOC_STRING;
	}

	// instantiate the appropriate subset bean.
	ItemBean subset;
	if (secSub.equalsIgnoreCase("y"))
		subset = new SecuritySubsetBean(session);
	else
		subset = new SubsetBean(session);

	subset.setMetaLocation(Integer.parseInt(subsetLoc));

	if (subsetKey != null && !subsetKey.equals("") && !subsetKey.equalsIgnoreCase("null")) {
		//there is a key so get the table value from the subset.
		subset.setMetaKey(subsetKey);
		subsetTableKey = subset.getAttributeValue("table");
		subsetTableLoc = subset.getAttributeValue("tableloc");
		try {
			// test this out.
			TableBean tb = new TableBean(session);
			if (subsetTableLoc == null || subsetTableLoc.equals(""))
				subsetTableLoc = ItemBean.PUBLIC_LOC_STRING;
			tb.setMetaLocation(Integer.parseInt(subsetTableLoc));
			tb.setMetaKey(subsetTableKey);
			String x = tb.getAttributeValue("desc");
		}
		catch (Exception e) {
			// had a problem accessing the table, so remove it.
			subsetTableKey = "";
			subsetTableLoc = "";
			subset.setAttributeValue("table", "");
			subset.setAttributeValue("tableloc", "");
			subset.write();
		}
		if (subsetTableLoc == null || subsetTableLoc.equals("")) {
			// no tableloc, so assume it's the same as the subset you are dealing with.
			subsetTableLoc = subsetLoc;
		}
	}

	// default these things to be enabled if applicable, they get disabled when an invalid subset is selected.
	String turnOff = "false";
	String turnOffButton = "false";
	String clearButtonActive = "class='button'";
	if (!hrvi.isUserAdmin(session) && subsetLoc.equals(ItemBean.PUBLIC_LOC_STRING)) {
		// a non - admin is viewing a public subset.
		turnOff = "true";
		clearButtonActive = "disabled class='buttonDis'";
	}
	if (subsetKey == null || subsetKey.equals("") || testParm.equals("delete") || testParm.equals("save")) {
		// there is no subset selected or it is about to be deleted or saved.
		turnOffButton = "true";
		clearButtonActive = "disabled class='buttonDis'";
	}
	String invalidClear = "document.subsetList.ibClear.disabled=" + turnOffButton + "; document.subsetList.ibDelete.disabled=" + turnOffButton + ";  document.subsetList.clause.disabled=" + turnOff + "; document.subsetList.desc.disabled=" + turnOff + ";";
	if (!secSub.equalsIgnoreCase("y")) {
		invalidClear += " parent.BUTTONS.btnForm.ibOk.disabled=false; parent.BUTTONS.btnForm.ibBuild.disabled=false; document.subsetList.tableName.disabled=" + turnOff + ";";
	}
	else
		invalidClear += "document.subsetList.key.disabled=" + turnOff + ";";

	// fetch the TableCtrl object.
	TableCtrl hrvTable;

	if (secSub.equalsIgnoreCase("y")) {
		// this is for a security subset, so default to empmast as the table/view if none given.
		loc = ItemBean.PUBLIC_LOC_STRING;
		if (subsetTableLoc.equals(""))
			subsetTableLoc = ItemBean.PUBLIC_LOC_STRING;
		if (subsetTableKey.equals(""))
			subsetTableKey = "empmast";
		currentView = "work." + subsetTableKey;
		hrvTable = (TableCtrl) hrvi.getSessionValue(session, "TABLE_" + subsetTableKey + "_sec");
		if (hrvTable == null) {
			// instantiate our table bean and set it up.
			hrvTable = new TableCtrl(session, subsetTableLoc, subsetTableKey);
			hrvi.setSessionValue(session, "table_" + subsetTableKey + "_sec", (Object) hrvTable);

			// need to get a tablectrl set up for empmast.
			// create a view using the MakeView object.
			MakeView hrvMakeView = hrvTable.getMakeView();
			hrvMakeView.setOutputType("view");
			hrvMakeView.setOutputName(subsetTableKey);
			currentView = hrvMakeView.create(subsetTableKey, ItemBean.PUBLIC_DATA_LIBREF, false);

			// now update the button frame.
%>

	<SCRIPT LANGUAGE=JavaScript>
		parent.BUTTONS.document.location = '../Jsp/subsetButtons.jsp?secSub=y&CURRENTVIEW=<%=currentView%>';
	</SCRIPT>

<%
		}
	}
	else {
		// not a security subset.
		hrvTable = (TableCtrl) hrvi.getSessionValue(session, "TABLE_" + currentView);
	}

	out.println("<input type=hidden name=\"CURRENTVIEW\" value=\"" + currentView + "\">");
	String tableDesc = hrvTable.getTableDescription();
	// if the key was not passed in on the url, get it from the tableCtrl object.
	if (key.equals(""))
		key = hrvTable.getTableKey();

	String selFind = "";
	if (!testParm.equals("backFromWhere") && !testParm.equals("edit") && !jsTestParm.equals("okSave") && (subsetKey == null || subsetKey.equalsIgnoreCase("null") || subsetKey.equals(""))) {
		// if we don't have a subsetKey value, then get it from the tableCtrl object.
		subsetKey = hrvTable.getFind();
		subsetLoc = hrvTable.getFindLoc();
		if (subsetKey != null && !subsetKey.equals("")) {
			// got a find key.
			selFind = "checked";
		}
		else {
			// see if there is a subset key.
			subsetKey = hrvTable.getSubset();
			subsetLoc = hrvTable.getSubsetLoc();
		}
		// enable the delete and clear buttons since a subset is highlighted.
		if (subsetKey != null && !subsetKey.equals("") && !subsetKey.equals("null"))
			invalidClear = invalidClear + "document.subsetList.ibDelete.disabled=false; document.subsetList.ibClear.disabled=false;";
	}

	// get the description of the table the subset is based on.
	TableBean tmpTB = new TableBean(session);
	try {
		if (subsetTableLoc != null && !subsetTableLoc.equals("")) {
			tmpTB.setMetaLocation(Integer.parseInt(subsetTableLoc));
			tmpTB.setMetaKey(subsetTableKey);
			subDesc = tmpTB.getAttributeValue("desc");
			currTbl = tmpTB.getAttributeValue("datasetname");
			if (currTbl == null)
				currTbl = "";
		}
		else {
			subDesc = tableDesc;
			currTbl = "";
		}
	}
	catch (KeyNotFoundException e) {
		subDesc = "";
		currTbl = "";
	}
	catch (InvalidRepositoryException e) {
		subDesc = "";
		currTbl = "";
	}

	// do actions conditional on the internalAction parameter (testParm).
	if (testParm != null &&
		((testParm.equals("save") && !jsTestParm.equals("okSave")) || testParm.equals("backFromWhere") ||
		(jsTestParm.equals("okSave") &&
		((!hrvi.isUserAdmin(session) && subsetLoc.equals(ItemBean.PRIVATE_LOC_STRING)) || hrvi.isUserAdmin(session))
		)
		)
		){
		// set subDesc to the current table since that is what is coded into the meta data.
		subDesc = tableDesc;
		// do the actual save part here.
		desc = request.getParameter("desc");
		subsetTableKey = request.getParameter("subsetTableKey");
		subsetLoc = request.getParameter("subsetLoc");
		subsetKey = request.getParameter("subsetKey");
		if (testParm.equals("backFromWhere")) {
			// enable the delete and clear buttons since a subset is highlighted.
			if (subsetKey != null && !subsetKey.equals("") && !subsetKey.equals("null"))
				invalidClear = invalidClear + "document.subsetList.ibDelete.disabled=false; document.subsetList.ibClear.disabled=false;";
			// re-enable the buttons in the button frame.
%>

<SCRIPT>
	parent.BUTTONS.btnForm.ibBuild.disabled=false;

<%
	if (!secSub.equalsIgnoreCase("y")) {
%>

	parent.BUTTONS.btnForm.ibOk.disabled=false;
	parent.BUTTONS.btnForm.ibCancel.disabled=false;

<%
	}
%>

</SCRIPT>

<%
			// get the where clause from the where clause builder.
			//WhereClauseBuilder wcbBack = (WhereClauseBuilder)hrvi.getSessionValue(session, request.getParameter("sessionkey"));
			//clause = wcbBack.getWhereString();
			clause = (String)session.getAttribute("wcb");
			
			//if null, set it to blank
			if(clause == null)
				clause = "";
		}
		String subType = request.getParameter("subType");
		if (subType == null)
			subType = "";
		String includeSelf = request.getParameter("includeSelf");
		if (includeSelf == null)
			includeSelf = "";
		if (!clause.equals("") || (secSub.equalsIgnoreCase("y") && (!subType.equals("") || !includeSelf.equals("")))) {
			if (!hrvi.isUserAdmin(session) && subsetLoc.equals(ItemBean.PUBLIC_LOC_STRING)) {
				// a non admin user is trying to save a subset, so it needs to be saved in private.
				subsetLoc = ItemBean.PRIVATE_LOC_STRING;
				subset.setMetaLocation(Integer.parseInt(subsetLoc));
				// if there is a key value, it is a public key they are copying, need to generate a
				// private key.
				subsetKey = "";
			}
			if (subsetKey == null || subsetKey.equals("") || subsetKey.equalsIgnoreCase("null")) {
				// this means that we are adding a new subset.
				subsetKey = subset.getNewMetaKey();
				// enable the delete and clear buttons since a subset is highlighted.
				invalidClear = invalidClear + "document.subsetList.ibDelete.disabled=false; document.subsetList.ibClear.disabled=false;";
			}
			if (subsetLoc != null && !subsetLoc.equals(""))
				subset.setMetaLocation(Integer.parseInt(subsetLoc));
			subset.setMetaKey(subsetKey);
			// now actually update the node with the new values.
			if (desc.equals("")) {
				// no description has been provided so mock one up.
				String newSubset = vM.getLabel("subsetNew");
				desc = newSubset + " - " + subsetKey;
			}
			subset.setAttributeValue("desc",desc);
			subset.setAttributeValue("table", key);
			subset.setAttributeValue("tableloc", loc);
			subset.setAttributeValue("clause",clause);

			// set the department heirarchy parameter if it is set.
			if (subType == null || subType.equals("") || (!subType.equalsIgnoreCase("findKey") && !subType.equalsIgnoreCase("y")))
				subset.setAttributeValue("deptheir","n");
			else
				subset.setAttributeValue("deptheir","y");

			// set the include self parameter if it is set.
			if (includeSelf == null || includeSelf.equals("") || (!includeSelf.equalsIgnoreCase("default") && !includeSelf.equalsIgnoreCase("y")))
				subset.setAttributeValue("includeself","n");
			else
				subset.setAttributeValue("includeself","y");

			subset.write();
			subset.resetMetaList();
			subset.setMetaKey("");
		}
	}
	else if (testParm != null && testParm.equals("delete")) {
		// do the actual save part here.
		if (subsetKey != null && !subsetKey.equals("")) {
			try {
				// this means that we have a key to delete.
				subset.setMetaKey(subsetKey);
				// now actually delete the subset.
				subset.removeItem();
				subset.resetMetaList();
				subset.setMetaKey("");
			}
			catch (KeyNotFoundException e){
				// key is not there so it is already deleted.
			}
			// blank out the values.
			desc = "";
			key = hrvTable.getTableKey();
			clause = "";
			htmlClause = "";
			subsetKey = "";
		}
	}
	else if (testParm != null && testParm.equals("edit")) {
		// set up the whereclausebuilder and forward to whereMain.jsp.
		// get the current table name (sas name).
		String tmpTbl = key;
		if (!currTbl.equals(""))
			tmpTbl = currTbl;
		if (loc.equals(ItemBean.PUBLIC_LOC_STRING))
			currTbl = ItemBean.PUBLIC_DATA_LIBREF + "." + tmpTbl;
		else
			currTbl = ItemBean.PRIVATE_DATA_LIBREF + "." + tmpTbl;

		// if there is a value in the desc text field, use that.
		String tmpDesc = request.getParameter("desc");
		if (tmpDesc != null && !tmpDesc.equals(""))
			desc = tmpDesc;
		// instantiate the WhereClauseBuilder object.
		String returnUrl = "../Jsp/openSubset.jsp?sessionkey={0}&selFind=" + URLEncoder.encode(selFind) + "&CURRENTVIEW=" + URLEncoder.encode(currentView) + "&subsetKey=" + URLEncoder.encode(subsetKey) + "&subsetLoc=" + URLEncoder.encode(subsetLoc) + "&ctrlButtons=" + URLEncoder.encode(ctrlButtons) + "&internalAction=backFromWhere&desc=" + URLEncoder.encode(desc) + "&secSub=" + URLEncoder.encode(secSub) + "&key=" + URLEncoder.encode(key) + "&loc=" + URLEncoder.encode(loc) + "&subsetTableKey=" + URLEncoder.encode(key) + "&subsetTableLoc=" + URLEncoder.encode(loc);
		String tmpSubType = subset.getAttributeValue("deptheir");
		if (tmpSubType == null)
			tmpSubType = "";
		returnUrl += "&subType=" + URLEncoder.encode(tmpSubType);
		WhereClauseBuilder wcb = WhereClauseBuilder.getInstance(session, returnUrl, currTbl, clause);
		hrvi.setSessionValue(session, "wcbKey_" + key, wcb);
%>

<SCRIPT LANGUAGE='JavaScript'>
	top.document.location.href = "../Query/whereMain.jsp?hideQueryLimit=y&sessionkey=wcbKey_<%=key%>&clause=<%=htmlClause%>";
</SCRIPT>

<%
	}
	if (testParm != null && (testParm.equals("clear") || (testParm.equals("save") && !jsTestParm.equals("okSave")))) {
		// blank out the key and clause values so the screen re-draws with no subset selected.
		subsetKey = "";
		PRVKEYTMP = "";
		PUBKEYTMP = "";
		clause = "";
		htmlClause = "";
		// set subDesc to the current table since that is what is coded into the meta data.
		subDesc = tableDesc;
	}

	// supposed to repopulate the text fields with the appropriate values.
	String jsFunc = "";
	if (subsetKey != null && !subsetKey.equalsIgnoreCase("null"))
		if (!subsetKey.equals("")) {
			// get values from the subset key.
			if (subsetLoc != null && !subsetLoc.equals("") && !subsetLoc.equalsIgnoreCase("null"))
				subset.setMetaLocation(Integer.parseInt(subsetLoc));
			subset.setMetaKey(subsetKey);
			desc = subset.getAttributeValue("desc");
			subsetTableKey = subset.getAttributeValue("table");
			subsetTableLoc = subset.getAttributeValue("tableloc");
			clause = subset.getAttributeValue("clause");
			// take the double quotes out of clause (replace them with &quot) for html.
			htmlClause = clause;
			int p = htmlClause.indexOf("\"");
			while (p >= 0) {
				htmlClause = htmlClause.substring(0,p) + "&quot;" + htmlClause.substring(p+1);
				p = htmlClause.indexOf("\"");
			}

			// determine if the dept. heir. / find checkbox should be checked.
			checked = subset.getAttributeValue("deptheir");
			String kk = subset.getMetaKey();
			if (checked != null && checked.equalsIgnoreCase("y"))
				checked = "checked";
			else
				checked = "";
			checkedSelf = subset.getAttributeValue("includeself");
			if (checkedSelf != null && checkedSelf.equalsIgnoreCase("y"))
				checkedSelf = "checked";
			else
				checkedSelf = "";

			subset.resetMetaList();
			subset.setMetaKey("");
		}
		else {
			// no key, so blank out the values.
			desc = "";
			key = hrvTable.getTableKey();
		}

	if (testParm != null && (testParm.equals("checkWhere") || !secSub.equalsIgnoreCase("y"))) {
		// get the actual where clause text to display.
		String dispClause;
		if (subsetKey == null || subsetKey.equals("")) {
			// no key so use the clause value directly.
			dispClause = clause;
		}
		else {
			// get it from the subsetKey value.
			subset.setMetaKey(subsetKey);
			dispClause = subset.getAttributeValue("clause");
		}
		// get the description of the table to check against.
		tmpTB.setMetaLocation(Integer.parseInt(loc));
		tmpTB.setMetaKey(key);
		String verifyDesc = tmpTB.getAttributeValue("desc");
		// check the validity of the where clause.
		MakeView mV = hrvTable.getMakeView();
		boolean validBool = false;
		String valid = vM.getLabel("notValid");
		if (dispClause == null || dispClause.equals("") || mV.isWhereClauseValid(currentView, dispClause)) {
			validBool = true;
			valid = vM.getLabel("valid");
		}

		// adjust for quotes.
		String q = "\"";
		String jscriptClause = dispClause;
		if (dispClause.indexOf("\"") >= 0 && dispClause.indexOf("\'") < 0)
			q = "'";
		else if (dispClause.indexOf("\"") < 0 && dispClause.indexOf("\'") >= 0)
			q = "\"";
		else if (dispClause.indexOf("\"") >= 0 && dispClause.indexOf("\'") >= 0)
			jscriptClause = desc;

		// now display the results if checkWhere or non-secsub and failed.
		if ((testParm != null && testParm.equals("checkWhere")) || (!secSub.equalsIgnoreCase("y") && !validBool)) {
%>

<SCRIPT LANGUAGE='JavaScript'>
	alert(<%=q%><%=jscriptClause%>\n <%=valid%>\n <%=verifyDesc%><%=q%>);
</SCRIPT>

<%
			// set up javascript to run so an invalid subset won't display.
			if (!secSub.equalsIgnoreCase("y") && !validBool) {
				if (testParm.equalsIgnoreCase("checkWhere")) {
					// just checking where so don't clear it out, but set based on if blank.
					if (subDesc.equals(""))
						subDesc = tableDesc;
				}
				else {
					// disable it.
	   			invalidClear = "document.subsetList.ibClear.disabled=false; document.subsetList.desc.disabled=true; document.subsetList.tableName.disabled=true;";

	   			if (!hrvi.isUserAdmin(session) && subsetLoc.equals(ItemBean.PUBLIC_LOC_STRING))
		   			invalidClear += "document.subsetList.ibDelete.disabled=true;";
		   		else
		   			invalidClear += "document.subsetList.ibDelete.disabled=false;";

					if (!secSub.equalsIgnoreCase("y")) {
						invalidClear += " parent.BUTTONS.btnForm.ibOk.disabled=true; parent.BUTTONS.btnForm.ibBuild.disabled=true;";
					}
	   		}
	   	}
		}
	}

	// set up the html to use to activate/inactivate the reset and clear buttons.
	String resetButtonActive = "document.subsetList.ibReset.disabled=true; document.subsetList.ibReset.className='buttonDis'";
	clearButtonActive = "disabled class='buttonDis'";
	if (subsetKey != null && !subsetKey.equals("")) {
		resetButtonActive = "document.subsetList.ibReset.disabled=false; document.subsetList.ibReset.className='button'";
		clearButtonActive = "class='button'";
	}
	else if (clause != null && !clause.equals(""))
		clearButtonActive = "class='button'";

	// set up the html to use to activate/inactivate the clause and name entry fields depending
	// upon if the user can actually edit this location.
	String editFields = "disabled";
	String initialSave = "class=\"button\" ";
	if ((hrvi.isUserAdmin(session) && subsetLoc.equals(ItemBean.PUBLIC_LOC_STRING)) || (!hrvi.isUserAdmin
	(session) && subsetLoc.equals(ItemBean.PRIVATE_LOC_STRING)) || subsetKey == null || subsetKey.equals("")) {
		editFields = "";
		initialSave = "class=\"buttonDis\" disabled";
	}
%>

<HEAD>
	<%@ include file="HRVHeadInclude.jsp"%>
</HEAD>
<BODY class="bodyContents">

<form ACTION=tableViewerRowSubset.jsp NAME="subsetList">

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
<tr>
<td valign="center"align="center">
	<p class="pagetitle"><%=tableDesc%></p>

   <table border="0" class="entrybox" cellpadding="8" cellspacing="0">
	<tr>
   <td>

<%
	if (secSub.equalsIgnoreCase("y")) {
%>

     <p><%=vM.getLabel("secSubsetDirection")%></p>

<%
	}
	else {
%>

     <p><%=vM.getLabel("subsetDirection")%></p>

<%
	}
%>

	  <p><%=vM.getLabel("subsetClause")%> <input ID="ifSubsetClause" type="text" value="<%=htmlClause%>" name="clause" size="80" <%=editFields%> onchange="document.subsetList.ibSave.disabled=false; document.subsetList.ibSave.className='button'; <%=resetButtonActive%>">
		  <a href="javascript:void 0; document.subsetList.internalAction.value='checkWhere'; document.subsetList.submit();"
			 onMouseOver="self.status='<%=vM.getLabel("validateMO")%>';return true;"
			 onMouseOut="self.status=''"><img src="../Images/icons/check.gif" border="0"></a></p>
		<hr>
		<table border="0" cellpadding="0" cellspacing="8">
		<tr>
			<td colspan="3">
			  <table border="0" cellpadding="0" cellspacing="8">
			  <tr>
			     <td><%=vM.getLabel("subsetName")%> </td>
			     <td><input type="field" name="desc" value="<%=desc%>" size="40"  <%=editFields%> onchange="document.subsetList.ibSave.disabled=false; document.subsetList.ibSave.className='button'; <%=resetButtonActive%>"></td>
			  </tr>
			  <tr>
			     <td><%=vM.getLabel("basedOn")%> </td>
				  <td>

<%
	String k, selected;
	if (secSub.equalsIgnoreCase("y")) {
		// for security subsets, give a list of tables to base the subset on.
%>

				  <SELECT NAME="key" SIZE="1" width="350" style="width:350" onchange="document.subsetList.ibSave.disabled=false; document.subsetList.ibSave.className='button'; <%=resetButtonActive%>">

<%
		TableBean tb = new TableBean(session);
		Vector v = new Vector();
		v.add("desc");
		v.add("datasetname");
		v.add("tbltype");
		NamedList secSubTables = tb.getItemsSortedWithAttributes("desc", v);
		NamedList subList = new NamedList();
		String dsname;
		String tempType;
		out.println("<OPTION VALUE=\"\">");
		for (int i=0; i<secSubTables.size(); i++) {
			subList = (NamedList) secSubTables.getValue(i);
			k = (String) subList.getValue("KEY");
			dsname = (String) subList.getValue("datasetname");
         tempType = (String) subList.getValue("tbltype");
         if (tempType == null || tempType.equals("") || tempType.equals("SAS") || tempType.equalsIgnoreCase("query") || tempType.equalsIgnoreCase("excel") || tempType.equalsIgnoreCase("hrv")) {
         	// these are legitimate tables, not mddbs.
				if (k.equalsIgnoreCase(subsetTableKey))
					selected = "SELECTED";
				else
					selected = "";
				if (dsname != null && !dsname.equals("")) {
					k += ":dsname=" + dsname;
				}
				out.println("<OPTION VALUE=\"" + k + "\" " + selected + ">"	+ secSubTables.getName(i));
			}
		}
		out.println("</SELECT>");
	}
	else {
%>

				  <input type="field" name="tableName" value="<%=subDesc%>" size="40" disabled>

<%
	}
%>

				  </td>
			  </tr>
			  </table>
			</td>
		</tr>
 		<tr>
			<td>
				<table border="0" cellpadding="0" cellspacing="0" width="350">
				<tr>
					<td class="barHeader"><%=vM.getLabel("pubSub")%></td>
				</tr>
				<tr>
				<td>
					<SELECT NAME="PUBKEYTMP" SIZE="10" width="350" style="width:350" onClick="

<%
		if (!hrvi.isUserAdmin(session)) {
%>

					document.subsetList.PRVKEYTMP.selectedIndex=-1;

<%
		}
%>

					document.subsetList.submit();">

<%
		// populate the select list with subset values.
		selected = "";
		subset.setMetaKey("");
		subset.setMetaLocation(ItemBean.PUBLIC_LOC);
		subset.resetMetaList();
		List sortItem = subset.getItemsSorted("desc");
		for (Iterator ti = sortItem.iterator(); ti.hasNext();) {
			k = (String) ti.next();
			subset.setMetaKey(k);
			if (k.equalsIgnoreCase(subsetKey) && subsetLoc.equals(ItemBean.PUBLIC_LOC_STRING))
				selected = "SELECTED";
			else
				selected = "";
			out.println("<OPTION VALUE=\"" + k + "\" " + selected + ">"	+ subset.getAttributeValue("desc"));
		}
%>

					</select>
				</td>
				</tr>
				</table>
			</td>
			<td width="10"></td>

<%
		if (!hrvi.isUserAdmin(session)) {
%>

			<td>
				<table border="0" cellpadding="0" cellspacing="0" width="350">
				<tr>
					<td class="barHeader"><%=vM.getLabel("prvSub")%></td>
				</tr>
				<tr>
				<td>
					<SELECT NAME="PRVKEYTMP" SIZE="10" width="350" style="width:350" onClick="document.subsetList.PUBKEYTMP.selectedIndex=-1; document.subsetList.submit();">

<%
		subset.setMetaLocation(ItemBean.PRIVATE_LOC);
		subset.setMetaKey("");
		subset.resetMetaList();
		sortItem = subset.getItemsSorted("desc");
		if (sortItem.size() > 0)
			for (Iterator ti = sortItem.iterator(); ti.hasNext();) {
				k = (String) ti.next();
				subset.setMetaKey(k);
				if (k.equalsIgnoreCase(subsetKey) && subsetLoc.equals(ItemBean.PRIVATE_LOC_STRING))
					selected = "SELECTED";
				else
					selected = "";
				out.println("<OPTION VALUE=\"" + k + "\" " + selected + ">"	+ subset.getAttributeValue("desc"));
			}
		subset.resetMetaList();
%>

					</select>
				</td>
				</tr>
				</table>
			</td>

<%
		}

		// set up the javascript to be run when clear is slected.
		String clearText = "document.subsetList.internalAction.value='clear';  document.subsetList.PUBKEYTMP.value=''; ";
		if (!hrvi.isUserAdmin(session))
			clearText += "document.subsetList.PRVKEYTMP.value='';";
		clearText += "document.subsetList.submit();";
%>

		</tr>
		<tr>
			<td colspan="3" valign="center" align="center">
				<input ID="ibSave" type="button" <%=initialSave%> value="<%=vM.getLabel("Save")%>"
					 onMouseOver="self.status='<%=vM.getLabel("subSaveMO")%>'"
					 onMouseOut="self.status=''" onClick="document.subsetList.internalAction.value='save'; document.subsetList.clause.disabled=false; document.subsetList.desc.disabled=false;  document.subsetList.submit();">
				<input ID="ibClear" type="button" value="<%=vM.getLabel("Clear")%>" <%=clearButtonActive%>
					 onClick="<%=clearText%>"
					 onMouseOver="self.status='<%=vM.getLabel("subClearMO")%>'"
					 onMouseOut="self.status=''">
				<input ID="ibReset" type="button" class="buttonDis" disabled value="<%=vM.getLabel("Reset")%>"
					 onMouseOver="self.status='<%=vM.getLabel("subResetMO")%>'"
					 onMouseOut="self.status=''" onClick="document.subsetList.internalAction.value='repopulate'; document.subsetList.submit();">

<%
	// set up wether the delete button is active or not.
	String activateButton = "class=\"buttonDis\" disabled";
	if (((subsetLoc.equals(ItemBean.PUBLIC_LOC_STRING) && hrvi.isUserAdmin(session)) || (subsetLoc.equals(ItemBean.PRIVATE_LOC_STRING) && !hrvi.isUserAdmin(session))) && subsetKey != null && !subsetKey.equals("") )
		activateButton = "class=\"button\" enabled";
%>

				<input ID="ibDelete" type="button" value="<%=vM.getLabel("Delete")%>"
					 onMouseOver="self.status='<%=vM.getLabel("subDeleteMO")%>'"
					 onMouseOut="self.status=''" <%=activateButton%> onClick="if (parent.BUTTONS.document.btnForm.subsetKey.value == '<%=subsetKey%>'){parent.BUTTONS.document.btnForm.subsetKey.value=''; parent.BUTTONS.document.btnForm.subsetLoc.value='';} if (parent.BUTTONS.document.btnForm.FIND.value == '<%=subsetKey%>'){parent.BUTTONS.document.btnForm.FIND.value=''; parent.BUTTONS.document.btnForm.findLoc.value='';}					 document.subsetList.internalAction.value='delete'; document.subsetList.submit();">
			</td>
		</tr>
		</table>
		<hr>

		<input type="checkbox" name="subType" value="findKey" id="icHighlight"

		onClick="document.subsetList.ibSave.disabled=false; document.subsetList.ibSave.className='button'; <%=resetButtonActive%>" <%=checked%>

		<%=selFind%>>
		<label for="icHighlight">

<%
	if (secSub.equalsIgnoreCase("y")) {
%>

		<%=vM.getLabel("securityHeir")%>


		</label>
		</br>

		<input type="checkbox" name="includeSelf" value="default" id="icIncludeSelf"

		onClick="document.subsetList.ibSave.disabled=false; document.subsetList.ibSave.className='button'; <%=resetButtonActive%>" <%=checkedSelf%>
		<%=selFind%>>

		<label for="icIncludeSelf">

		<%=vM.getLabel("includeSelf")%>
<%
	}
	else {
%>

		<%=vM.getLabel("subsetHighlight")%>

<%
	}
%>

	</label>
	</TD>
	</tr>
	</table>
</td>
</tr>
</table>

<INPUT TYPE=hidden NAME="internalAction" VALUE="repopulate">
<INPUT TYPE=hidden NAME="ctrlButtons" VALUE="<%=ctrlButtons%>">
<INPUT TYPE=hidden NAME="CURRENTVIEW" VALUE="<%=currentView%>">
<INPUT TYPE=hidden NAME="loc" VALUE="<%=loc%>">
<INPUT TYPE=hidden NAME="key" VALUE="<%=key%>">
<INPUT TYPE=hidden NAME="subsetLoc" VALUE="<%=subsetLoc%>">
<INPUT TYPE=hidden NAME="subsetKey" VALUE="<%=subsetKey%>">
<INPUT TYPE=hidden NAME="subsetTableLoc" VALUE="<%=subsetTableLoc%>">
<INPUT TYPE=hidden NAME="subsetTableKey" VALUE="<%=subsetTableKey%>">
<INPUT TYPE=hidden NAME="secSub" VALUE="<%=secSub%>">
<INPUT TYPE=hidden NAME="jsTestParm" VALUE="">
</form>

<%
	if (jsTestParm.equals("okSave")) {
		// run some javascript in the button frame.
%>

<SCRIPT LANGUAGE='JavaScript'>
	parent.BUTTONS.getVals();
	parent.BUTTONS.document.btnForm.submit();
</SCRIPT>

<%
	}
%>

<SCRIPT LANGUAGE='JavaScript'>
	<%=invalidClear%>
</SCRIPT>

</BODY>
</HTML>