 <%
 /*********************************************************************/
 // Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
 /*********************************************************************/
 //
 // NAME:     userlistc.jsp
 // AUTHOR:   sastgl - Tim Lehman
 // SUPPORT:  sastgl - Tim Lehman
 // PRODUCT:  hrvision
 // TYPE:     jsp page
 // LANGUAGE: java
 // PURPOSE:  Display the attributes for a specific HR Vision user
 //
 // HISTORY:   Date    Who     Action
 //           -------------------------------------------------------
 //           06Sep00  TGL     initial coding
 //	      	  21Apr01  maperr  added desc sort & pwd encryption
 /*********************************************************************/
 %>

 <%@page import="java.io.*,java.util.*" %>
 <%@page import="com.sas.hrv.*" %>
 <%@page import="com.sas.rmi.Connection" %>
 <%@page import="com.sas.sasserver.submit.*" %>
 <%@page import="com.sas.hrv.register.*" %>
 <%@page import="com.sas.rmi.Rocf" %>



 <%@include file="HRVLoginInclude.jsp"%>
 <%@include file="auxItem.jsp"%>

 <%!
  // global declarations
  	String keyAttrName = "USER";
  	String targetJSP = "userlist.jsp";
  	String _self_ = "userlistc.jsp";
  	String attrNuemonic = "UserAttr_";
  	String currentAttribute = "";
  	boolean f;
	UserBean userBean = null;
	Rocf rocf = null;
	Connection con = null;
 %>

 <%!

// update the values for one row item
void updateNewValues(HttpSession session, String key, NamedList attrList, NamedList parmList)
 	throws IOException, Exception, InvalidUserException {

 	//need to convert sec code description to sec code
 	//need to also convert subset description to subset name
	String attr, oldvalue, newvalue, val, desc, end;
	boolean rc = false;
	boolean newkey;
	boolean success;

	CodeBean cb = HrvInfo.getCodeBean(session);
	HrvInfo hrvi = HrvInfo.getInstance();
	JspWriter out = hrvi.getJspWriter(session);
	// Create a UserBean for our use
	userBean = new UserBean(session);

	//if the key has spaces, replace them with an underscore
	key = key.replace(' ', '_');
	//Lowercase the key
	key=key.toLowerCase();

	// see if this is a valid key, create if necessary
	try {

		cb.setUser(key);
		newkey = false;
		success = true;
	}
	catch (Exception e) {
		newkey = true;

		try {
			cb.addUser(key);
			success = true;

		}
		catch (Exception f) {
			success = false;
		}
	}

	//*******************
	//if the security code attribute is missing. Add it to the NamedList and assign it a blank.
	String secParmValue = (String)parmList.getValue("seccode");
	if(secParmValue == null){
		String secAttrValue = (String)attrList.getValue("seccode");
		if(secAttrValue == null || secAttrValue.equals(""))
			parmList.add("seccode", "");
		else
			parmList.add("seccode", secAttrValue);
	}
	//*******************


	for (int i=0; i < attrList.length(); i++) {
 		attr = attrList.getName(i);
 		oldvalue = (String) attrList.getValue(attr);

 		//changes seccode from desc to actual code
 		if(attr.equalsIgnoreCase("seccode")){
			desc = (String)parmList.getValue("seccode");
			if(desc != null && !desc.equals("")){
				val = cb.getCodeByDesc(desc);
				int strLength = val.length();
				end = val.substring(strLength - 1);
				if(end.equals(",")){
					val = val.substring(0,strLength - 1);
				}
				parmList.set(attr, val);
			}
 		}

 		//changes subset from desc to actual code
 		if(attr.equalsIgnoreCase("subset")){
			SecuritySubsetBean sS = new SecuritySubsetBean(session);
			desc = (String)parmList.getValue("subset");

			List item = sS.getItems();
			String subKey,attrValue,subVal;
			Object[] items = item.toArray();

			if(desc != null) {
				if(!desc.equals("")) {
					StringTokenizer st = new StringTokenizer(desc, "**");
					String tokenizedCodes = "";

					while(st.hasMoreTokens()){
						String tokenDesc = st.nextToken();
						for(int j=0; j < item.size(); j++) {
							subKey = (String)items[j];
							sS.setMetaKey(subKey);
							attrValue = sS.getAttributeValue("desc");

							if(attrValue.equalsIgnoreCase(tokenDesc)) {
								tokenizedCodes += subKey + "**";
							}
						}
					}
					tokenizedCodes = tokenizedCodes.substring(0, tokenizedCodes.length() -2);
					//cb.setUserAttributeValue(attr, tokenizedCodes);
					parmList.set(attr, tokenizedCodes);
				}
			}
		}

 		if (parmList.indexOfName(attr) >= 0 ) {
 			newvalue = (String) parmList.getValue(attr);
 			//if newvalue does not equal the old one
 			if (!newvalue.equals(oldvalue) || newkey) {
 				//**if attr = encryptpw...run encrypt method on string newvalue
 				if (attr.equals("encryptpw") && !newvalue.trim().equals("")){
 					//if seccode equals SYSADM don't do this
 					String security = (String)parmList.getValue("seccode");
 					String changePass = (String)hrvi.getConfigValue( "force.password.change");
 					if (changePass == null)
 						changePass = "YES";
 					else
 						changePass = changePass.toUpperCase();
 					if(!security.equalsIgnoreCase("SYSADM")) {
 						if (!(changePass.equals("NO") || changePass.equals("N") || changePass.equals("OFF")))
 							cb.setUserAttributeValue("newPass","YES");
					}
 					newvalue = userBean.encrypt(newvalue);
 				}
 				if (!attr.equals("encryptpw") || !newvalue.trim().equals("")){
 					//set the new value in the attrList
 					attrList.set(attr,newvalue);
					cb.setUserAttributeValue(attr,newvalue);
				}
			}
		}
	}
	cb.writeUser();


	//if we succesfully wrote a new user. Create their folders

	if(newkey == true){
		String root,folderRoot, one, two, three, four, five, regMeta, whKey;
		ConnectionInterface cI = null;
		try{
		  	cI = ConnectionInterface.getInstance(session);
		  	rocf = cI.getRocf();
		  	con = cI.getCon();

		}
		catch(Exception conInt){
			System.out.println("Could not get a connection interface");
		}


		WarehouseBean wb = hrvi.getWarehouseBean(session);
		whKey = hrvi.getWarehouse(session);
		//get the users root path and data path
		root = wb.getUserDataPath();
		folderRoot = root.concat("/" + key);

  		try{
			REGISTERInterface SCLInterface =
				(REGISTERInterface) rocf.newInstance( "com.sas.hrv.register.REGISTERInterface",con );

			one = SCLInterface.createUserDir(root, key);
			two = SCLInterface.createUserDir(folderRoot, "data");
			three = SCLInterface.createUserDir(folderRoot, "output");
			five = SCLInterface.createUserDir(folderRoot, "reports");
			four = SCLInterface.createUserDir(folderRoot, "repos_" + whKey);

			regMeta = SCLInterface.registerMetabase(folderRoot, whKey);
			if ( regMeta.equals("Repository registration unsuccessful."))
			{
				String regpath = folderRoot + "/repos_" + whKey;
				StringBuffer sbuf = new StringBuffer();
				sbuf.append("%reposcleanup(path=" + regpath + ", all=y);");
				cI.submit(sbuf.toString());
				sbuf.replace(0,sbuf.length(),"");

				// Try registration one more time
				regMeta = SCLInterface.registerMetabase(folderRoot, whKey);

				if ( regMeta.equals("Repository registration unsuccessful."))
				{
					sbuf.append("%reposcleanup(path=" + regpath + ", all=y);");
					cI.submit(sbuf.toString());
					sbuf.replace(0,sbuf.length(),"");

					VisMsg vM = VisMsg.getInstance(session);
					try
					{
						Exception error = new Exception(vM.getSentence( "CMRError" ) +  ".");
						throw error;
					}
					catch (Exception error)
					{
						out.println(error.toString());
					}

				}
			}
		}
		catch (Exception sclErr)
		{
			System.out.println("Exception " + sclErr.toString());
		}
	}
 }


void searchForUser(HttpSession session, String criteria, NamedList parmList, NamedList possibleList, NamedList displayList, AuxItem AI) throws Exception {

	List keyList = new ArrayList();
	CodeBean cb = HrvInfo.getCodeBean(session);

	try{
		keyList = cb.getUsersSorted("");
	}catch(Exception e){
		System.out.println(e);
	}

	if(keyList.contains(criteria)){
		//match found. Display it
		try{
			int indexOfKey = keyList.indexOf(criteria);
			String index = Integer.toString(indexOfKey);
			session.setAttribute("sort", "USER");
			session.setAttribute("currentNum", index);
		}catch(Exception e){
			System.out.println(e);
		}
	}else{
		//id does not exist... Start list with first letter
		try{
			String firstLetter = criteria.substring(0, 1);
			for(int i=0; i < keyList.size(); i++){
				String key = (String)keyList.get(i);
				if(key.startsWith(firstLetter)){
					String newIndex = Integer.toString(i);
					session.setAttribute("currentNum", newIndex);
					session.setAttribute("sort", "USER");
					break;
				}
			}
		}catch(Exception n){
			System.out.println("Go To field left blank");
		}
	}
	keyList(session, parmList, possibleList, displayList, AI);
}

// write the entire table, this method must call AI.writeAllRows
void keyList(HttpSession session, NamedList parmList, NamedList possibleList, NamedList displayList, AuxItem AI)
		throws Exception {
	possibleList.remove("encryptpw");
	possibleList.remove("email");

	String idvalue, attr, value ;
	CodeBean cb = HrvInfo.getCodeBean(session);
	String currentUser = HrvInfo.getUser(session);
	VisMsg VM = VisMsg.getInstance(session);
	userBean = new UserBean(session);

	// see if there was a sort parameter
	String sort = (String)parmList.getValue("sort");
	if (sort == null) sort = (String)session.getAttribute("sort");
	if (sort == null) sort = "USER";

	cb.resetUserList();
	List keyList;

	String savedSort = (String)session.getAttribute("sort");

	//if this is firs load or sort has changed set the sort on the session.
	if(savedSort == null || !savedSort.equals(sort)){
		session.setAttribute("sort", sort);
		session.setAttribute("sortOrder", "assending");
		String newIndex = "0";
		session.setAttribute("currentNum", newIndex);
	}
	String sortOrder = (String)session.getAttribute("sortOrder");
	if(sortOrder == null)
		sortOrder = "assending";

	cb.userBean.setUser("SYSADM", true);
	try {
		if(sortOrder.equalsIgnoreCase("assending")){

			if(!sort.equalsIgnoreCase("USER"))
				keyList = cb.getUsersSorted(sort);
			else
				keyList = userBean.getUsersSorted("KEY",true);

			session.setAttribute("sortOrder", "decending");
		}else{
			if(!sort.equalsIgnoreCase("USER"))
				keyList = cb.getUserSortedDesc(sort);
			else
				keyList = userBean.getUsersSorted("KEY",false);

			session.setAttribute("sortOrder", "assending");
		}
	}
	catch (Exception e) {
		keyList = new ArrayList();
	}

	OptionBean oB = OptionBean.getInstance(session);
	String numberUsers = (String)oB.getOption("users_rows");
	int displayNumber = Integer.parseInt(numberUsers);

	String currentNum = (String)session.getAttribute("currentNum");
	int currentNumber = Integer.parseInt(currentNum);

	if((currentNumber - displayNumber) < 0){
		currentNumber = 0;
		session.setAttribute("currentNum", "0");
	}

	String allKeys[] = new String[displayNumber];
	String allItems[][] = new String[displayNumber][possibleList.size()];
	String allColumns[] = new String[possibleList.size()];

	int numberOfUsers = keyList.size();

	boolean end = false;
	int d = 0;
	for(int i = currentNumber; i < currentNumber + displayNumber; i++){
		//check to see if we are at the end of the users
		if(i > keyList.size() - 1){
			end = true;
			break;
		}

		try{
			idvalue = (String)keyList.get(i);
		}catch(Exception e){
			//trying to go past the beggining
			break;
		}

		allKeys[d] = idvalue;
		try {
			cb.setUser(idvalue);
		}
		catch (InvalidUserException e) {
			continue;
		}
		cb.resetUserAttributeList();
		for (int j = 0;j < possibleList.size();j++){
			attr = possibleList.getName(j);
			allColumns[j] = attr;

			value = cb.getUserAttributeValue(attr);

			if(value != null && !attr.equalsIgnoreCase("subset") && !attr.equalsIgnoreCase("seccode")){
				if(attr.equalsIgnoreCase("mddbdetail") || attr.equalsIgnoreCase("sasreport")){
					if(value.equalsIgnoreCase("YES"))
						value = VM.getLabel("Yes");
					else if(value.equalsIgnoreCase("NO"))
						value = VM.getLabel("No");
				}
				else{
					if(value.equalsIgnoreCase("YES"))
						value = VM.getLabel("Show");
					else if(value.equalsIgnoreCase("NO"))
						value = VM.getLabel("Hide");
				}
			}

			//if security subset, use description and not key
			if(attr.equalsIgnoreCase("subset")){
				SecuritySubsetBean subset = new SecuritySubsetBean(session);
				try{
					StringTokenizer st = new StringTokenizer(value, "**");
					value = "";
					while(st.hasMoreTokens()){
						String tokenKey = st.nextToken();
						subset.setMetaKey(tokenKey);
						value += subset.getAttributeValue("desc") + ",";
					}

					value = value.substring(0, value.length() - 1);

				}catch(Exception e){
					//delete the item from the users metadata
					cb.setUserAttributeValue(attr, "");
					cb.writeUser();
					value = "";
				}
			}

			//cleans up the table formatting
			if (value == null || value.equals(""))
			{
				value = "&nbsp;";
			}
			allItems[d][j] = value;
		}
		d++;
	}
	cb.setUser(currentUser);
	AI.writeUsersRows(allKeys, allItems, allColumns, session, currentNumber, numberOfUsers, displayNumber, end);
 }


 // load up the initial attribute values for this key
 boolean initKeys(HttpSession session, String key, NamedList attrList, String mode)
 	throws Exception{
	CodeBean cb = HrvInfo.getCodeBean(session);
	// if necessary, remove all entries in the list
	if (mode.equals("INIT")) attrList.clear();

	// set all entries to blank
	for (int i=0; i < attrList.length(); i++) {
		attrList.setValue("",i);
	}
	// see if this is a valid key
	try {
		cb.setUser(key);
	}
	catch (Exception e) {
		return false;
	}

	cb.resetUserAttributeList();
	while (cb.nextUserAttribute()) {
		if (mode == "INIT")
			attrList.add(cb.getUserAttributeName(),cb.getUserAttributeValue());
		else
			attrList.set(cb.getUserAttributeName(),cb.getUserAttributeValue());
	}
	for(int j=0; j < attrList.length(); j++){
		if(attrList.getName(j) == "subset"){
			SecuritySubsetBean subset = new SecuritySubsetBean(session);
			String val =(String) attrList.getValue(j);
			String desc="";

			try{
				StringTokenizer st = new StringTokenizer(val, "**");
				while(st.hasMoreTokens()){
					String tokenKey = st.nextToken();
					subset.setMetaKey(tokenKey);
					//delimit the description by two **
					desc += subset.getAttributeValue("desc") + "**";
				}
				desc = desc.substring(0, desc.length() - 2);

			}catch(Exception e){
				//if an exception is thrown, the sec code has been deleted..Remove it from users metadata
				cb.setUserAttributeValue("subset","");
				cb.writeUser();
			}

			if(desc != null)
				attrList.set("subset", desc);
		}
		if(attrList.getName(j) == "seccode"){
			String secVal = (String)attrList.getValue(j);
			String codes,desc;
			int i = 0;
			StringBuffer sb = new StringBuffer();
			StringTokenizer st = new StringTokenizer(secVal,",");

			while (st.hasMoreTokens()) {
				i++;
				codes = st.nextToken();
				try{
					desc = cb.getAttributeValue(codes,"desc");
					sb.append(desc);
					if(i > 0)
						sb.append("**");
			}catch(Exception e){
				 //if an exception is thrown the seccode has been deleted.
				 cb.setUserAttributeValue("seccode", "");
				 cb.writeUser();
			}
		}
		String secDesc = sb.toString();
		if(secDesc !=null)
				attrList.set("seccode", secDesc);
		}
	}
	attrList.remove("email");
	return true;
 }


 // enforce the key naming rules, what should they be?
 boolean validItemName(String key) {
   if (key == null) return false;
 	if (key.equals(null)) return false;
 	return true;
 }


 // delete an item
 void deleteItem(HttpSession session, String key)
 	throws Exception {

	ConnectionInterface cI = null;
	try{
		cI = ConnectionInterface.getInstance(session);
		rocf = cI.getRocf();
		con = cI.getCon();

	}catch(Exception conInt){
		System.out.println("Could not get a connection interface");
	}
 	HrvInfo hrvi = HrvInfo.getInstance();
 	CodeBean cb = HrvInfo.getCodeBean(session);
	cb.userBean.setUser("SYSADM", true);
	cb.removeUser(key);

	//Adding code to remove the users folders
	WarehouseBean wb = hrvi.getWarehouseBean(session);
	String whKey = hrvi.getWarehouse(session);
	//get the users root path and data path
	String root = wb.getUserDataPath();

	//attempting to delete the metadata side
	try{
		String metaPath = hrvi.getWarehousePath(session);
		String userMetaPath = "";
		if(metaPath.endsWith("/") || metaPath.endsWith("\\"))
			userMetaPath = metaPath.concat("userdata/" + key);
		else
			userMetaPath = metaPath.concat("/userdata/" + key);

		File userPath = new File(userMetaPath);
		deleteDirectoryRecursive(userPath);
		userPath.delete();

	}catch(Exception e){

		System.out.println(e);
	}



	String folderRoot = root.concat("/" + key);

	try{
		REGISTERInterface SCLInterface =
			(REGISTERInterface) rocf.newInstance( "com.sas.hrv.register.REGISTERInterface",con );

		String two = SCLInterface.deleteUserDir(folderRoot, "data");
		String three = SCLInterface.deleteUserDir(folderRoot, "output");
		String five = SCLInterface.deleteUserDir(folderRoot, "reports");
		String four = SCLInterface.deleteUserDir(folderRoot, "repos_" + whKey);
	}catch(Exception e){
		System.out.println("Error Deleting Users Folders: " + e);
	}
  }

//this method recursivly deletes all of a users metadata folders
public void deleteDirectoryRecursive(File path) throws IOException {


	  File[] files = path.listFiles();

	  for(int i=0; i<files.length; ++i) {

		 if(files[i].isDirectory())
			deleteDirectoryRecursive(files[i]);

		 files[i].delete();
	  }
}

 // fills a list of those attributes which need to have some kind of choice selection next to their value
 void getChoiceList(HttpSession session, NamedList attrList, NamedList choiceList)
 	throws Exception {
	String attr,desc;

 	for (int i=0; i < attrList.length(); i++) {

 		attr = attrList.getName(i).toUpperCase();
		if (attr.equalsIgnoreCase("SECCODE")) {
			Set codes = HrvInfo.getCodeBean(session).getSecurityCodes();
			String[] description = new String[codes.size()];

			Object[] test = codes.toArray();
			for(int j=0; j <test.length; j++){
				desc = (String)test[j];
				if(desc !=null && !desc.equals("")){

					desc = HrvInfo.getCodeBean(session).getAttributeValue(desc, "desc");
					description[j] = desc;
				}
			}
			choiceList.add(attr, description);
			//set to 3 to allow multiple selections
			choiceList.add(attr + "_num","3");
		}
		else if (attr.equalsIgnoreCase("EBDATE")) {
			choiceList.add(attr,"DATE");
		}
		else if (attr.equalsIgnoreCase("EEDATE")) {
			choiceList.add(attr,"DATE");
		}
		else if (attr.equalsIgnoreCase("SUBSET")) {
			SecuritySubsetBean secSubset = new SecuritySubsetBean(session);
			List subsetList = secSubset.getItems();
			Object[] test = subsetList.toArray();
			String[] description = new String[test.length];

			for(int j=0; j < test.length; j++){
				desc = (String)test[j];
				if(desc !=null && !desc.equals("")){
					secSubset.setMetaKey(desc);
					try{
						desc = secSubset.getAttributeValue("desc");
					}catch(Exception e){
						System.out.println("Exception: " + e);
					}
					description[j] = desc;
				}
			}

			choiceList.add(attr, description);
			//set to 1 to allow only one choice
			choiceList.add(attr + "_num","3");
		}
		//this block sets up the drop list for the show/hide type attributes
		else if(attr.equalsIgnoreCase("SASLOG") || attr.equalsIgnoreCase("HOME") || attr.equalsIgnoreCase("EMPPROFILE") || attr.equalsIgnoreCase("TABLES") || attr.equalsIgnoreCase("REPORTS") || attr.equalsIgnoreCase("ANALYSES") || attr.equalsIgnoreCase("BOOKMARK") || attr.equalsIgnoreCase("CONFIGURE")) {
			VisMsg vM = VisMsg.getInstance(session);
			String show = vM.getLabel("Show");
			String hide = vM.getLabel("Hide");
			String[] log = {show,hide};
			choiceList.add(attr,log);
			//set to 1 to allow only one choice
			choiceList.add(attr + "_num", "1");
		}

		else if(attr.equalsIgnoreCase("CONFIGURE") || attr.equalsIgnoreCase("HOMECUST_BTN") || attr.equalsIgnoreCase("TABLE_RD_BTN") || attr.equalsIgnoreCase("QUERY_BTN") || attr.equalsIgnoreCase("REPORT_RD_BTN") || attr.equalsIgnoreCase("ANALYTIC_BTN") || attr.equalsIgnoreCase("ANALYTIC_RD_BTN") || attr.equalsIgnoreCase("TABLENEW") || attr.equalsIgnoreCase("REPORTNEW") ){
			VisMsg vM = VisMsg.getInstance(session);
			String show = vM.getLabel("Show");
			String hide = vM.getLabel("Hide");
			String[] log = {show,hide};
			choiceList.add(attr,log);
			//set to 1 to allow only one choice
			choiceList.add(attr + "_num", "5");
		}
		else if(attr.equalsIgnoreCase("TEMPLATE")){
			HrvInfo hrvi = HrvInfo.getInstance();
			CodeBean cb = hrvi.getCodeBean(session);
			List templates = cb.userBean.getUserTemplates();
			if(templates != null){
				String [] temps = new String[templates.size()];
				for(int x=0; x < temps.length; x++){
					temps [x] = (String)templates.get(x);
				}
				choiceList.add(attr, temps);
				choiceList.add(attr + "_num", "4");
			}
			else{
				//there are no template, put up an empty choice list
				String [] empty = new String[0];
				choiceList.add(attr, empty);
				choiceList.add(attr + "_num", "4");
			}
		}
		//this block sets up the drop list for the yes/no type attributes
		else if(attr.equalsIgnoreCase("MDDBDETAIL") || attr.equalsIgnoreCase("SASREPORT")) {
			VisMsg vM = VisMsg.getInstance(session);
			String yes = vM.getLabel("Yes");
			String no = vM.getLabel("No");
			String[] log = {yes,no};
			choiceList.add(attr,log);
			//set to 1 to allow only one choice
			choiceList.add(attr + "_num", "2");
		}
		else {
			choiceList.add(attr,null);
		}
	}
 }


 //fills a list of those keys which cannot be deleted
 void fillNoDeleteList(LinkedList noDeleteList) {
 	noDeleteList.add("SYSADM");
  	noDeleteList.add("HRUSER");
 }


 %>